//==========================================================================
// File : MimeOle.pas
//
// Definitions for Windows Mail API in Delphi, according to the Windows 2003
// version of the Microsoft Platform SDK
//
// Author : K. Giddings
//
//
// This source code is the property of its authors and may not be
// redistributed or reproduced in any form without the written
// permission of the authors.
//
// You may freely use this unit in the creation of any software. 
//
// Copyright (C) 2007 GP Software (Thame) Ltd
//
// This software is provided 'as-is', without any express or implied
// warranty.  In no event will the authors be held liable for any damages
// arising from the use of this software.
//
//==========================================================================
unit MimeOle;

interface

uses
  Windows, ActiveX,variants;

// partial conversion - these are not done yet!

//interface IMimePropertySet;
//interface IMimeMessageW;
//interface IMimeBodyW;
//interface IMimeEnumHeaderRows;
//interface IMimeAddressTableW;
//interface IMimeInternational;
//interface IMimeEnumProperties;
//interface IMimeSecurityCallback;
//interface IPersistMime;
//interface IMimeSecurity2;
//interface INewsgroupHelp;
//interface IHashTableW;
const
  LIBID_MIMEOLE : TGUID = '{E4B28371-83B0-11d0-8259-00C04FD85AB4}';
  CLSID_IMimeHtmlProtocol : TGUID = '{05300401-BCBC-11d0-85E3-00C04FD85AB4}';
  IID_IMimeEnumAddressTypes : TGUID = '{C5588354-7F86-11d0-8252-00C04FD85AB4}';
  IID_IMimeWebDocument : TGUID = '{EE519F11-851A-11d0-825C-00C04FD85AB4}';
  IID_IUnicodeStream : TGUID = '{FD853CEF-7F86-11d0-8252-00C04FD85AB4}';
  IID_IMimeAddressTable : TGUID = '{C558834A-7F86-11d0-8252-00C04FD85AB4}';
  IID_IMimeAddressTableW : TGUID = '{11C8D742-0FB4-11d3-A01E-00A0C90C9BB6}';
  IID_IMimeAddressInfo : TGUID = '{C558834B-7F86-11d0-8252-00C04FD85AB4}';
  IID_IMimeEnumHeaderRows : TGUID = '{C558834D-7F86-11d0-8252-00C04FD85AB4}';
  IID_IMimeInlineSupport : TGUID = '{C558834E-7F86-11d0-8252-00C04FD85AB4}';
  IID_IMimeEnumMessageParts : TGUID = '{C5588350-7F86-11d0-8252-00C04FD85AB4}';
  CLSID_IMimeInternational : TGUID = '{FD853CD9-7F86-11d0-8252-00C04FD85AB4}';
  IID_IMimeInternational : TGUID = '{C5588349-7F86-11d0-8252-00C04FD85AB4}';
  CLSID_IMimeBody : TGUID = '{FD853CDB-7F86-11d0-8252-00C04FD85AB4}';
  IID_IMimeBody : TGUID = '{C558834C-7F86-11d0-8252-00C04FD85AB4}';
  CLSID_IMimeBodyW : TGUID = '{2F38042A-D02F-11d2-A004-00A0C90C9BB6}';
  IID_IMimeBodyW : TGUID = '{2F38042B-D02F-11d2-A004-00A0C90C9BB6}';
  CLSID_IMimeMessageParts : TGUID = '{FD853CDC-7F86-11d0-8252-00C04FD85AB4}';
  IID_IMimeMessageParts : TGUID = '{C558834F-7F86-11d0-8252-00C04FD85AB4}';
  CLSID_IMimeAllocator : TGUID = '{FD853CDD-7F86-11d0-8252-00C04FD85AB4}';
  IID_IMimeAllocator : TGUID = '{C5588351-7F86-11d0-8252-00C04FD85AB4}';
  CLSID_IMimeSecurity : TGUID = '{FD853CDE-7F86-11d0-8252-00C04FD85AB4}';
  IID_IMimeSecurity : TGUID = '{C5588353-7F86-11d0-8252-00C04FD85AB4}';
  CLSID_IVirtualStream : TGUID = '{FD853CDF-7F86-11d0-8252-00C04FD85AB4}';
  IID_IVirtualStream : TGUID = '{C5588359-7F86-11d0-8252-00C04FD85AB4}';
  CLSID_IMimeHeaderTable : TGUID = '{FD853CE0-7F86-11d0-8252-00C04FD85AB4}';
  IID_IMimeHeaderTable : TGUID = '{FD853CD1-7F86-11d0-8252-00C04FD85AB4}';
  CLSID_IMimePropertySet : TGUID = '{FD853CE1-7F86-11d0-8252-00C04FD85AB4}';
  IID_IMimePropertySet : TGUID = '{FD853CD3-7F86-11d0-8252-00C04FD85AB4}';
  CLSID_IMimeMessageTree : TGUID = '{FD853CE2-7F86-11d0-8252-00C04FD85AB4}';
  IID_IMimeMessageTree : TGUID = '{FD853CD4-7F86-11d0-8252-00C04FD85AB4}';
  CLSID_IMimeMessage : TGUID = '{FD853CE3-7F86-11d0-8252-00C04FD85AB4}';
  IID_IMimeMessage : TGUID = '{FD853CD5-7F86-11d0-8252-00C04FD85AB4}';
  CLSID_IMimeMessageW : TGUID = '{F90ADFEE-D01F-11d2-A004-00A0C90C9BB6}';
  IID_IMimeMessageW : TGUID = '{F90ADFEF-D01F-11d2-A004-00A0C90C9BB6}';
  CLSID_IMimePropertySchema : TGUID = '{FD853CED-7F86-11d0-8252-00C04FD85AB4}';
  IID_IMimePropertySchema : TGUID = '{FD853CEC-7F86-11d0-8252-00C04FD85AB4}';
  IID_IMimeEnumProperties : TGUID = '{FD853CEE-7F86-11d0-8252-00C04FD85AB4}';
  IID_IPersistMime : TGUID = '{DE4AD8DA-555F-11d1-8DD0-00C04FB951F9}';
  IID_IMimeMessageCallback : TGUID = '{761AA641-7BDA-11d1-8AA9-00C04FB951F3}';
  CLSID_MimeEdit : TGUID = '{1C82EAD9-508E-11d1-8DCF-00C04FB951F9}';
  CMDSETID_MimeEdit : TGUID = '{1C82EADA-508E-11d1-8DCF-00C04FB951F9}';
  CMDSETID_MimeEditHost : TGUID = '{1C82EADB-508E-11d1-8DCF-00C04FB951F9}';
  IID_IHashTable : TGUID = '{64577981-86D7-11d1-BDFC-00C04FA31009}';
  CLSID_IHashTable : TGUID = '{64577982-86D7-11d1-BDFC-00C04FA31009}';
  CLSID_IFontCache : TGUID = '{B0D17FC2-7BC4-11d1-BDFA-00C04FA31009}';
  IID_IFontCache : TGUID = '{B0D17FC4-7BC4-11d1-BDFA-00C04FA31009}';
  IID_IFontCacheNotify : TGUID = '{B0D17FC5-7BC4-11d1-BDFA-00C04FA31009}';
  CLSID_IMimeObjResolver : TGUID = '{35461E30-C488-11d1-960E-00C04FBD7C09}';
  IID_IMimeObjResolver : TGUID = '{FECEAFFD-C441-11d1-960E-00C04FBD7C09}';
  IID_IMimeEditTag : TGUID = '{70183210-7b36-11d2-8c12-00c04fa31009}';
  IID_IMimeSecurityCallback : TGUID = '{ba715ae0-a740-11d2-8b22-0080c76b34c6}';
  CLSID_INewsgroupHelp : TGUID = '{7A0CC021-2939-4379-AA82-12AECC3538F6}';
  IID_INewsgroupHelp : TGUID = '{0887C54F-4F42-4937-81DA-BC9C97494627}';
  IID_IHashTableW : TGUID = '{71d6b38c-7a15-42c6-af84-b2a5dc242ceb}';
  CLSID_IHashTableW : TGUID = '{71d6b38d-7a15-42c6-af84-b2a5dc242ceb}';
  IID_IMimeEditTagCollection : TGUID = '{d09ee528-7b38-11d2-8c12-00c04fa31009}';
  CLSID_PreviewEmail : TGUID = '{b9815375-5d7f-4ce2-9245-c9d4da436930}';
  CLSID_PreviewHtml : TGUID = '{f8b8412b-dea3-4130-b36c-5e8be73106ac}';
  CLSID_PreviewMime : TGUID = '{92dbad9f-5025-49b0-9078-2d78f935e341}';

  SID_IMimeEnumAddressTypes = '{C5588354-7F86-11d0-8252-00C04FD85AB4}';
  SID_IMimeWebDocument = '{EE519F11-851A-11d0-825C-00C04FD85AB4}';
  SID_IUnicodeStream = '{FD853CEF-7F86-11d0-8252-00C04FD85AB4}';
  SID_IMimeAddressTable = '{C558834A-7F86-11d0-8252-00C04FD85AB4}';
  SID_IMimeAddressTableW = '{11C8D742-0FB4-11d3-A01E-00A0C90C9BB6}';
  SID_IMimeAddressInfo  = '{C558834B-7F86-11d0-8252-00C04FD85AB4}';
  SID_IMimeEnumHeaderRows = '{C558834D-7F86-11d0-8252-00C04FD85AB4}';
  SID_IMimeInlineSupport = '{C558834E-7F86-11d0-8252-00C04FD85AB4}';
  SID_IMimeEnumMessageParts = '{C5588350-7F86-11d0-8252-00C04FD85AB4}';
  SID_IMimeInternational  = '{C5588349-7F86-11d0-8252-00C04FD85AB4}';
  SID_IMimeBody = '{C558834C-7F86-11d0-8252-00C04FD85AB4}';
  SID_IMimeBodyW = '{2F38042B-D02F-11d2-A004-00A0C90C9BB6}';
  SID_IMimeMessageParts = '{C558834F-7F86-11d0-8252-00C04FD85AB4}';
  SID_IMimeAllocator = '{C5588351-7F86-11d0-8252-00C04FD85AB4}';
  SID_IMimeSecurity = '{C5588353-7F86-11d0-8252-00C04FD85AB4}';
  SID_IVirtualStream = '{C5588359-7F86-11d0-8252-00C04FD85AB4}';
  SID_IMimeHeaderTable = '{FD853CD1-7F86-11d0-8252-00C04FD85AB4}';
  SID_IMimePropertySet = '{FD853CD3-7F86-11d0-8252-00C04FD85AB4}';
  SID_IMimeMessageTree = '{FD853CD4-7F86-11d0-8252-00C04FD85AB4}';
  SID_IMimeMessage = '{FD853CD5-7F86-11d0-8252-00C04FD85AB4}';
  SID_IMimeMessageW = '{F90ADFEF-D01F-11d2-A004-00A0C90C9BB6}';
  SID_IMimePropertySchema = '{FD853CEC-7F86-11d0-8252-00C04FD85AB4}';
  SID_IMimeEnumProperties = '{FD853CEE-7F86-11d0-8252-00C04FD85AB4}';
  SID_IPersistMime = '{DE4AD8DA-555F-11d1-8DD0-00C04FB951F9}';
  SID_IMimeMessageCallback = '{761AA641-7BDA-11d1-8AA9-00C04FB951F3}';
  SID_IHashTable = '{64577981-86D7-11d1-BDFC-00C04FA31009}';
  SID_IFontCache = '{B0D17FC4-7BC4-11d1-BDFA-00C04FA31009}';
  SID_IFontCacheNotify = '{B0D17FC5-7BC4-11d1-BDFA-00C04FA31009}';
  SID_IMimeObjResolver  = '{FECEAFFD-C441-11d1-960E-00C04FBD7C09}';
  SID_IMimeEditTag = '{70183210-7b36-11d2-8c12-00c04fa31009}';
  SID_IMimeSecurityCallback  = '{ba715ae0-a740-11d2-8b22-0080c76b34c6}';
  SID_INewsgroupHelp = '{0887C54F-4F42-4937-81DA-BC9C97494627}';
  SID_IHashTableW = '{71d6b38c-7a15-42c6-af84-b2a5dc242ceb}';
  SID_IMimeEditTagCollection = '{d09ee528-7b38-11d2-8c12-00c04fa31009}';

  MIME_E_REG_CREATE_KEY                = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE01;
  MIME_E_REG_QUERY_INFO                = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE02;
  MIME_E_INVALID_ENCTYPE               = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE03;
  MIME_E_BOUNDARY_MISMATCH             = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE04;
  MIME_E_NOT_FOUND                     = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE05;
  MIME_E_NO_DATA                       = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE05;
  MIME_E_BUFFER_TOO_SMALL              = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE06;
  MIME_E_INVALID_ITEM_FLAGS            = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE07;
  MIME_E_ONE_LINE_ITEM                 = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE08;
  MIME_E_INVALID_HANDLE                = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE09;
  MIME_E_CHARSET_TRANSLATE             = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE0A;
  MIME_E_NOT_INITIALIZED               = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE0B;
  MIME_E_NO_MORE_ROWS                  = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE0C;
  MIME_E_ALREADY_BOUND                 = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE0D;
  MIME_E_CANT_RESET_ROOT               = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE0E;
  MIME_E_INSERT_NOT_ALLOWED            = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE0F;
  MIME_E_BAD_BODY_LOCATION             = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE10;
  MIME_E_NOT_MULTIPART                 = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE11;
  MIME_E_NO_MULTIPART_BOUNDARY         = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE12;
  MIME_E_CONVERT_NOT_NEEDED            = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE13;
  MIME_E_CANT_MOVE_BODY                = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE14;
  MIME_E_UNKNOWN_BODYTREE_VERSION      = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE15;
  MIME_E_NOTHING_TO_SAVE               = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE16;
  MIME_E_NEED_SAVE_MESSAGE             = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE17;
  MIME_E_NOTHING_TO_REVERT             = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE18;
  MIME_E_MSG_SIZE_DIFF                 = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE19;
  MIME_E_CANT_RESET_PARENT             = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE1A;
  MIME_E_CORRUPT_CACHE_TREE            = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE1B;
  MIME_E_BODYTREE_OUT_OF_SYNC          = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE1C;
  MIME_E_INVALID_ENCODINGTYPE          = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE1D;
  MIME_E_MULTIPART_NO_DATA             = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE1E;
  MIME_E_INVALID_OPTION_VALUE          = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE1F;
  MIME_E_INVALID_OPTION_ID             = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE20;
  MIME_E_INVALID_HEADER_NAME           = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE21;
  MIME_E_NOT_BOUND                     = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE22;
  MIME_E_MAX_SIZE_TOO_SMALL            = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE23;
  MIME_E_MULTIPART_HAS_CHILDREN        = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE25;
  MIME_E_INVALID_PROP_FLAGS            = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE26;
  MIME_E_INVALID_ADDRESS_TYPE          = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE27;
  MIME_E_INVALID_OBJECT_IID            = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE28;
  MIME_E_MLANG_DLL_NOT_FOUND           = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE29;
  MIME_E_ROOT_NOT_EMPTY                = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE2A;
  MIME_E_MLANG_BAD_DLL                 = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE2B;
  MIME_E_REG_OPEN_KEY                  = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE2C;
  MIME_E_INVALID_INET_DATE             = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE2D;
  MIME_E_INVALID_BODYTYPE              = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE2E;
  MIME_E_INVALID_DELETE_TYPE           = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE2F;
  MIME_E_OPTION_HAS_NO_VALUE           = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE30;
  MIME_E_INVALID_CHARSET_TYPE          = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE31;
  MIME_E_VARTYPE_NO_CONVERT            = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE32;
  MIME_E_INVALID_VARTYPE               = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE33;
  MIME_E_NO_MORE_ADDRESS_TYPES         = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE34;
  MIME_E_INVALID_ENCODING_TYPE         = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE35;
  MIME_S_ILLEGAL_LINES_FOUND           = (SEVERITY_SUCCESS shl 31) or (FACILITY_INTERNET shl 16) or $CE36;
  MIME_S_MIME_VERSION                  = (SEVERITY_SUCCESS shl 31) or (FACILITY_INTERNET shl 16) or $CE37;
  MIME_E_INVALID_TEXT_TYPE             = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE38;
  MIME_E_READ_ONLY                     = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE39;
  MIME_S_INVALID_MESSAGE               = (SEVERITY_SUCCESS shl 31) or (FACILITY_INTERNET shl 16) or $CE3A;
  MIME_S_CHARSET_CONFLICT              = (SEVERITY_SUCCESS shl 31) or (FACILITY_INTERNET shl 16) or $CE3B;
  MIME_E_UNSUPPORTED_VARTYPE           = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE3C;
  MIME_S_NO_CHARSET_CONVERT            = (SEVERITY_SUCCESS shl 31) or (FACILITY_INTERNET shl 16) or $CE3D;
  MIME_E_URL_NOTFOUND                  = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE3E;
  MIME_E_BAD_TEXT_DATA                 = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CE3F;
  MIME_E_NO_SIGNER                     = (SEVERITY_SUCCESS shl 31) or (FACILITY_INTERNET shl 16) or $CE40;


  MIME_E_SECURITY_NOTINIT              = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CEA0;
  MIME_E_SECURITY_LOADCRYPT32          = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CEA1;
  MIME_E_SECURITY_BADPROCADDR          = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CEA2;
  MIME_E_SECURITY_NODEFAULT            = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CEB0;
  MIME_E_SECURITY_NOOP                 = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CEB1;
  MIME_S_SECURITY_NOOP                 = (SEVERITY_SUCCESS shl 31) or (FACILITY_INTERNET shl 16) or $CEB1;
  MIME_S_SECURITY_NONE                 = (SEVERITY_SUCCESS shl 31) or (FACILITY_INTERNET shl 16) or $CEB2;
  MIME_S_SECURITY_ERROROCCURED         = (SEVERITY_SUCCESS shl 31) or (FACILITY_INTERNET shl 16) or $CEB3;
  MIME_E_SECURITY_USERCHOICE           = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CEB4;
  MIME_E_SECURITY_UNKMSGTYPE           = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CEB5;
  MIME_E_SECURITY_BADMESSAGE           = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CEB6;
  MIME_E_SECURITY_BADCONTENT           = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CEB7;
  MIME_E_SECURITY_BADSECURETYPE        = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CEB8;
  MIME_E_SECURITY_CLASSNOTSUPPORTED    = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CEB9;
  MIME_S_SECURITY_RECURSEONLY          = (SEVERITY_SUCCESS shl 31) or (FACILITY_INTERNET shl 16) or $CEBA;
  MIME_E_SECURITY_BADSTORE             = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CED0;
  MIME_S_SECURITY_NOCERT               = (SEVERITY_SUCCESS shl 31) or (FACILITY_INTERNET shl 16) or $CED1;
  MIME_E_SECURITY_NOCERT               = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CED1;
  MIME_E_SECURITY_CERTERROR            = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CED2;
  MIME_S_SECURITY_CERTERROR            = (SEVERITY_SUCCESS shl 31) or (FACILITY_INTERNET shl 16) or $CED2;
  MIME_S_SECURITY_NODEFCERT            = (SEVERITY_SUCCESS shl 31) or (FACILITY_INTERNET shl 16) or $CED3;
  MIME_E_SECURITY_BADSIGNATURE         = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CEE0;
  MIME_E_SECURITY_MULTSIGNERS          = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CEE1;
  MIME_E_SECURITY_NOSIGNINGCERT        = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CEE2;
  MIME_E_SECURITY_CANTDECRYPT          = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CEF0;
  MIME_E_SECURITY_ENCRYPTNOSENDERCERT  = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CEF1;
  MIME_S_SECURITY_NOSENDERCERT         = (SEVERITY_SUCCESS shl 31) or (FACILITY_INTERNET shl 16) or $CEF2;
  MIME_E_SECURITY_LABELACCESSDENIED    = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CEF3;
  MIME_E_SECURITY_LABELACCESSCANCELLED = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CEF4;
  MIME_E_SECURITY_LABELCORRUPT         = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CEF5;
  MIME_E_SECURITY_UIREQUIRED           = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CEF6;
  MIME_E_SECURITY_RECEIPT_NOMATCHINGRECEIPTBODY  = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CEF7;
  MIME_E_SECURITY_RECEIPT_MSGHASHMISMATCH        = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CEF8;
  MIME_E_SECURITY_RECEIPT_CANTDECODE             = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CEF9;
  MIME_E_SECURITY_RECEIPT_CANTFINDSENTITEM       = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CEFA;
  MIME_E_SECURITY_RECEIPT_CANTFINDORGMSG         = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CEFB;
  MIME_E_SECURITY_LABELUIREQUIRED                = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CEFC;
  MIME_S_RECEIPT_FROMMYSELF                      = (SEVERITY_SUCCESS shl 31) or (FACILITY_INTERNET shl 16) or $CEFC;
  MIME_E_SECURITY_NOTIMPLEMENTED                 = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $CEFD;
  MIMEEDIT_E_UNEXPECTED                        = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $1700;
  MIMEEDIT_E_DODEFAULT                         = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $1701;
  MIMEEDIT_E_LOADLIBRARYFAILURE                = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $1702;
  MIMEEDIT_E_USERCANCEL                        = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $1703;
  MIMEEDIT_E_CHARSETNOTFOUND                   = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $1704;
  MIMEEDIT_E_ILLEGALBODYFORMAT                 = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $1705;
  MIMEEDIT_E_CANNOTSAVEUNTILPARSECOMPLETE      = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $1706;
  MIMEEDIT_E_CANNOTSAVEWHILESOURCEEDITING      = (SEVERITY_ERROR shl 31) or (FACILITY_INTERNET shl 16) or $1707;
  MIMEEDIT_S_OPENFILE                          = (SEVERITY_SUCCESS shl 31) or (FACILITY_INTERNET shl 16) or $1750;
  MIMEEDIT_S_SAVEFILE                          = (SEVERITY_SUCCESS shl 31) or (FACILITY_INTERNET shl 16) or $1751;
  MIMEEDIT_W_DOWNLOADNOTCOMPLETE               = (SEVERITY_SUCCESS shl 31) or (FACILITY_INTERNET shl 16) or $1760;
  MIMEEDIT_W_BADURLSNOTATTACHED                = (SEVERITY_SUCCESS shl 31) or (FACILITY_INTERNET shl 16) or $1761;

  STR_HDR_FROM               = 'From';
  STR_HDR_TO                 = 'To';
  STR_HDR_CC                 = 'Cc';
  STR_HDR_BCC                = 'Bcc';
  STR_HDR_SENDER             = 'Sender';
  STR_HDR_REPLYTO            = 'Reply-To';
  STR_HDR_RETURNPATH         = 'Return-Path';
  STR_HDR_RR                 = 'Rr';
  STR_HDR_RETRCPTTO          = 'Return-Receipt-To';
  STR_HDR_APPARTO            = 'Apparently-To';
  STR_HDR_DATE               = 'Date';
  STR_HDR_RECEIVED           = 'Received';
  STR_HDR_MESSAGEID          = 'Message-ID';
  STR_HDR_XMAILER            = 'X-Mailer';
  STR_HDR_ENCODING           = 'Encoding';
  STR_HDR_ENCRYPTED          = 'Encrypted';
  STR_HDR_COMMENT            = 'Comment';
  STR_HDR_SUBJECT            = 'Subject';
  STR_HDR_MIMEVER            = 'MIME-Version';
  STR_HDR_CNTTYPE            = 'Content-Type';
  STR_HDR_CNTXFER            = 'Content-Transfer-Encoding';
  STR_HDR_CNTID              = 'Content-ID';
  STR_HDR_CNTDESC            = 'Content-Description';
  STR_HDR_CNTDISP            = 'Content-Disposition';
  STR_HDR_CNTBASE            = 'Content-Base';
  STR_HDR_CNTLOC             = 'Content-Location';
  STR_HDR_NEWSGROUPS         = 'Newsgroups';
  STR_HDR_PATH               = 'Path';
  STR_HDR_FOLLOWUPTO         = 'Followup-To';
  STR_HDR_EXPIRES            = 'Expires';
  STR_HDR_REFS               = 'References';

  STR_HDR_INREPLYTO          = 'In-Reply-To';
  STR_HDR_CONTROL            = 'Control';

  STR_HDR_DISTRIB            = 'Distribution';
  STR_HDR_KEYWORDS           = 'Keywords';
  STR_HDR_SUMMARY            = 'Summary';
  STR_HDR_APPROVED           = 'Approved';
  STR_HDR_LINES              = 'Lines';
  STR_HDR_XREF               = 'Xref';
  STR_HDR_ORG                = 'Organization';
  STR_HDR_XNEWSRDR           = 'X-Newsreader';
  STR_HDR_XPRI               = 'X-Priority';
  STR_HDR_XMSPRI             = 'X-MSMail-Priority';
  STR_HDR_OFFSETS            = 'X-Offsets';
  STR_HDR_XUNSENT            = 'X-Unsent';
  STR_HDR_ARTICLEID          = 'X-ArticleId';
  STR_HDR_NEWSGROUP          = 'X-Newsgroup';
  STR_HDR_XVOICEMAIL         = 'X-VoiceMail';
  STR_HDR_XMSOESREC          = 'X-MSOESRec';

  STR_HDR_XRFC2646           = 'X-RFC2646';
  STR_HDR_XRFC2646_FLOWED    = 'Format=Flowed';
  STR_HDR_XRFC2646_RESPONSE  = 'Response';
  STR_HDR_XRFC2646_NEW       = 'Original';

  STR_HDR_POSTID             = 'X-MS-CommunityGroup-PostID';
  STR_HDR_MESSAGECATEGORY    = 'X-MS-CommunityGroup-MessageCategory';
  STR_HDR_THREADID           = 'X-MS-CommunityGroup-ThreadID';
  STR_HDR_PARENTID           = 'X-MS-CommunityGroup-ParentID';

  STR_PAR_CHARSET            = 'par:content-type:charset';
  STR_PAR_NUMBER             = 'par:content-type:number';
  STR_PAR_TOTAL              = 'par:content-type:total';
  STR_PAR_ID                 = 'par:content-type:id';
  STR_PAR_BOUNDARY           = 'par:content-type:boundary';
  STR_PAR_NAME               = 'par:content-type:name';
  STR_PAR_PROTOCOL           = 'par:content-type:protocol';
  STR_PAR_MICALG             = 'par:content-type:micalg';
  STR_PAR_FILENAME           = 'par:content-disposition:filename';
  STR_PAR_TYPE               = 'par:content-type:type';
  STR_PAR_START              = 'par:content-type:start';

  STR_PAR_ACCESSTYPE         = 'par:content-type:access-type';
  STR_PAR_XURL               = 'par:content-type:X-URL';
  STR_PAR_SIZE               = 'par:content-type:size';
  STR_PAR_SMIMETYPE          = 'par:content-type:smime-type';
  STR_PAR_REPORTTYPE         = 'par:Content-Type:report-type';
  STR_PAR_FORMAT             = 'par:Content-Type:format';
  STR_PAR_REPLYTYPE          = 'par:Content-Type:reply-type';

  STR_ATT_FILENAME           = 'att:filename';
  STR_ATT_GENFNAME           = 'att:generated-filename';
  STR_ATT_PRITYPE            = 'att:pri-content-type';
  STR_ATT_SUBTYPE            = 'att:sub-content-type';
  STR_ATT_NORMSUBJ           = 'att:normalized-subject';
  STR_ATT_ILLEGAL            = 'att:illegal-lines';
  STR_ATT_RENDERED           = 'att:rendered= ';  // VT_UI4 - TRUE or FALSE")
  STR_ATT_AUTOINLINED        = 'att:auto-inlined= ';  // VT_UI4 - TRUE or FALSE")
  STR_ATT_SENTTIME           = 'att:sent-time';
  STR_ATT_RECVTIME           = 'att:received-time';
  STR_ATT_PRIORITY           = 'att:priority';
  STR_ATT_SERVER             = 'att:athena-server= ';  // VT_LPSTR")
  STR_ATT_FORMAT             = 'att:format= ';  // VT_LPSTR")
  STR_ATT_ACCOUNTNAME        = 'att:athena-account-name= ';  // VT_LPSTR")
  STR_ATT_UIDL               = 'att:athena-pop3-uidl= ';  // VT_LPSTR")
  STR_ATT_STOREMSGID         = 'att:athena-store-msgid= ';  // VT_UI4")
  STR_ATT_USERNAME           = 'att:athena-user-name= ';  // VT_LPSTR")
  STR_ATT_FORWARDTO          = 'att:athena-forward-to= ';  // VT_LPSTR")
  STR_ATT_STOREFOLDERID      = 'att:athena-store-fdrid= ';  // VT_UI4")
  STR_ATT_GHOSTED            = 'att:athena-ghosted= ';  // VT_I4")
  STR_ATT_UNCACHEDSIZE       = 'att:athena-uncachedsize= ';  // VT_UI4")
  STR_ATT_COMBINED           = 'att:athena-combined= ';  // VT_UI4")
  STR_ATT_ACCOUNTID          = 'att:athena-account-id= ';  // VT_LPSTR")

  STR_MIME_TEXT_PLAIN        = 'text/plain';
  STR_MIME_TEXT_HTML         = 'text/html';
  STR_MIME_APPL_STREAM       = 'application/octet-stream';
  STR_MIME_MPART_MIXED       = 'multipart/mixed';
  STR_MIME_MPART_ALT         = 'multipart/alternative';
  STR_MIME_MPART_RELATED     = 'multipart/related';
  STR_MIME_MSG_PART          = 'message/partial';
  STR_MIME_MSG_RFC822        = 'message/rfc822';
  STR_MIME_APPLY_MSTNEF      = 'application/ms-tnef';
  STR_MIME_APPL_PKCS7SIG     = 'application/x-pkcs7-signature';
  STR_MIME_APPL_PKCS7SIG_1   = 'application/pkcs7-signature';
  STR_MIME_TEXT_ENRCICHED    = 'text/enriched';

  STR_CNT_TEXT                 = 'text';
  STR_CNT_MULTIPART             = 'multipart';
  STR_CNT_MESSAGE             = 'message';
  STR_CNT_IMAGE                 = 'image';
  STR_CNT_AUDIO                 = 'audio';
  STR_CNT_VIDEO                 = 'video';
  STR_CNT_APPLICATION         = 'application';
  STR_CNT_APPLICATIONW        = 'application';

  STR_SUB_PLAIN              = 'plain';
  STR_SUB_HTML               = 'html';
  STR_SUB_ENRICHED           = 'enriched';
  STR_SUB_RTF                = 'ms-rtf';
  STR_SUB_MIXED              = 'mixed';
  STR_SUB_PARALLEL           = 'parallel';
  STR_SUB_DIGEST             = 'digest';
  STR_SUB_RELATED            = 'related';
  STR_SUB_ALTERNATIVE        = 'alternative';
  STR_SUB_RFC822             = 'rfc822';
  STR_SUB_PARTIAL            = 'partial';
  STR_SUB_EXTERNAL           = 'external-body';
  STR_SUB_OCTETSTREAM        = 'octet-stream';
  STR_SUB_OCTETSTREAMW       = 'octet-stream';
  STR_SUB_POSTSCRIPT         = 'postscript';
  STR_SUB_GIF                = 'gif';
  STR_SUB_JPEG               = 'jpeg';
  STR_SUB_BASIC              = 'basic';
  STR_SUB_MPEG               = 'mpeg';
  STR_SUB_MSTNEF             = 'ms-tnef';
  STR_SUB_MSWORD             = 'msword';
  STR_SUB_WAV                = 'wav';
  STR_SUB_PKCS7MIME          = 'pkcs7-mime= ';  // non-standard")
  STR_SUB_PKCS7SIG           = 'pkcs7-signature= ';  // non-standard")
  STR_SUB_XPKCS7MIME         = 'x-pkcs7-mime';
  STR_SUB_XPKCS7SIG          = 'x-pkcs7-signature';
  STR_SUB_SIGNED             = 'signed';
  STR_SUB_BINHEX             = 'mac-binhex40';
  STR_SUB_VCARD              = 'x-vcard';

  STR_ENC_7BIT               = '7bit';
  STR_ENC_QP                 = 'quoted-printable';
  STR_ENC_BASE64             = 'base64';
  STR_ENC_8BIT               = '8bit';
  STR_ENC_BINARY             = 'binary';
  STR_ENC_UUENCODE           = 'uuencode';
  STR_ENC_XUUENCODE          = 'x-uuencode';
  STR_ENC_XUUE               = 'x-uue';
  STR_ENC_BINHEX40           = 'mac-binhex40';

  STR_FORMAT_FLOWED          = 'flowed';
  STR_REPLYTYPE_ORIGINAL     = 'original';
  STR_REPLYTYPE_RESPONSE     = 'response';

  STR_DIS_INLINE             = 'inline';
  STR_DIS_ATTACHMENT         = 'attachment';
  STR_DIS_ATTACHMENTW        = 'attachment';

  STR_PRO_SHA1               = 'sha1';
  STR_PRO_MD5                = 'rsa-md5';

  STR_PRI_MS_HIGH            = 'High';
  STR_PRI_MS_NORMAL          = 'Normal';
  STR_PRI_MS_LOW             = 'Low';
  STR_PRI_HIGH               = '1';
  STR_PRI_NORMAL             = '3';
  STR_PRI_LOW                = '5';
  STR_HDR_ORIG_RECIPIENT     = 'Original-Recipient';
  STR_HDR_DISP_NOTIFICATION_TO = 'Disposition-Notification-To';

  STR_CF_HTML                = 'HTML Format';
  STR_CF_INETMSG             = 'Internet Message (rfc822/rfc1522)';
  STR_CF_RFC822              = 'message/rfc822';

  STR_SMT_SIGNEDDATA         = 'signed-data= '; 
  STR_SMT_ENVELOPEDDATA      = 'enveloped-data= '; 
  STR_SMT_SIGNEDRECEIPT      = 'signed-receipt= ';

  PID_BASE                   = 2;

type
  MIMEPROPID = DWORD;

const
  PID_HDR_NEWSGROUP       = 2;
  PID_HDR_NEWSGROUPS      = 3;
  PID_HDR_REFS            = 4;
  PID_HDR_SUBJECT         = 5;
  PID_HDR_FROM            = 6;
  PID_HDR_MESSAGEID       = 7;
  PID_HDR_RETURNPATH      = 8;
  PID_HDR_RR              = 9;
  PID_HDR_RETRCPTTO       = 10;
  PID_HDR_APPARTO         = 11;
  PID_HDR_DATE            = 12;
  PID_HDR_RECEIVED        = 13;
  PID_HDR_REPLYTO         = 14;
  PID_HDR_XMAILER         = 15;
  PID_HDR_BCC             = 16;
  PID_HDR_MIMEVER         = 17;
  PID_HDR_CNTTYPE         = 18;
  PID_HDR_CNTXFER         = 19;
  PID_HDR_CNTID           = 20;
  PID_HDR_CNTDESC         = 21;
  PID_HDR_CNTDISP         = 22;
  PID_HDR_CNTBASE         = 23;
  PID_HDR_CNTLOC          = 24;
  PID_HDR_TO              = 25;
  PID_HDR_PATH            = 26;
  PID_HDR_FOLLOWUPTO      = 27;
  PID_HDR_EXPIRES         = 28;
  PID_HDR_CC              = 29;
  PID_HDR_CONTROL         = 30;
  PID_HDR_DISTRIB         = 31;
  PID_HDR_KEYWORDS        = 32;
  PID_HDR_SUMMARY         = 33;
  PID_HDR_APPROVED        = 34;
  PID_HDR_LINES           = 35;
  PID_HDR_XREF            = 36;
  PID_HDR_ORG             = 37;
  PID_HDR_XNEWSRDR        = 38;
  PID_HDR_XPRI            = 39;
  PID_HDR_XMSPRI          = 40;
  PID_PAR_FILENAME        = 41;
  PID_PAR_BOUNDARY        = 42;
  PID_PAR_CHARSET         = 43;
  PID_PAR_NAME            = 44;
  PID_ATT_FILENAME        = 45;
  PID_ATT_GENFNAME        = 46;
  PID_ATT_PRITYPE         = 47;
  PID_ATT_SUBTYPE         = 48;
  PID_ATT_NORMSUBJ        = 49;
  PID_ATT_ILLEGAL         = 50;
  PID_ATT_RENDERED        = 51;
  PID_ATT_SENTTIME        = 52;
  PID_ATT_RECVTIME        = 53;
  PID_ATT_PRIORITY        = 54;
  PID_HDR_COMMENT         = 55;
  PID_HDR_ENCODING        = 56;
  PID_HDR_ENCRYPTED       = 57;
  PID_HDR_OFFSETS         = 58;
  PID_HDR_XUNSENT         = 59;
  PID_HDR_ARTICLEID       = 60;
  PID_HDR_SENDER          = 61;
  PID_ATT_SERVER          = 62;
  PID_ATT_ACCOUNTID       = 63;
  PID_ATT_UIDL            = 64;
  PID_ATT_STOREMSGID      = 65;
  PID_ATT_USERNAME        = 66;
  PID_ATT_FORWARDTO       = 67;
  PID_ATT_STOREFOLDERID   = 68;
  PID_ATT_GHOSTED         = 69;
  PID_ATT_UNCACHEDSIZE    = 70;
  PID_ATT_COMBINED        = 71;
  PID_ATT_AUTOINLINED     = 72;
  PID_HDR_DISP_NOTIFICATION_TO     = 73;
  PID_PAR_REPLYTYPE       = 74;
  PID_PAR_FORMAT          = 75;
  PID_ATT_FORMAT          = 76;
  PID_HDR_INREPLYTO       = 77;
  PID_ATT_ACCOUNTNAME     = 78;
  PID_LAST                = 79;

  OID_ALLOW_8BIT_HEADER           = 1 shl 16 or VT_BOOL;
  OID_CBMAX_HEADER_LINE           = 2 shl 16 or VT_UI4;
  OID_SAVE_FORMAT                 = 3 shl 16 or VT_UI4;
  OID_WRAP_BODY_TEXT              = 4 shl 16 or VT_BOOL;
  OID_CBMAX_BODY_LINE             = 5 shl 16 or VT_UI4;
  OID_TRANSMIT_BODY_ENCODING      = 6 shl 16 or VT_UI4;
  OID_TRANSMIT_TEXT_ENCODING      = 7 shl 16 or VT_UI4;
  OID_GENERATE_MESSAGE_ID         = 8 shl 16 or VT_BOOL;
  OID_HIDE_TNEF_ATTACHMENTS       = $e shl 16 or VT_BOOL;
  OID_CLEANUP_TREE_ON_SAVE        = $f shl 16 or VT_BOOL;
  OID_BODY_REMOVE_NBSP            = $14 shl 16 or VT_BOOL;
  OID_DEFAULT_BODY_CHARSET        = $15 shl 16 or VT_UI4;
  OID_DEFAULT_HEADER_CHARSET      = $16 shl 16 or VT_UI4;
  OID_DBCS_ESCAPE_IS_8BIT         = $17 shl 16 or VT_BOOL;
  OID_SECURITY_TYPE               = $18 shl 16 or VT_UI4;
  OID_SECURITY_ALG_HASH           = $19 shl 16 or VT_BLOB;
  OID_SECURITY_ALG_BULK           = $20 shl 16 or VT_BLOB;
  OID_SECURITY_CERT_SIGNING       = $21 shl 16 or VT_UI4;
  OID_SECURITY_CERT_DECRYPTION    = $22 shl 16 or VT_UI4;
  OID_SECURITY_RG_CERT_ENCRYPT    = $23 shl 16 or VT_VECTOR or VT_UI4;
  OID_SECURITY_HCERTSTORE         = $24 shl 16 or VT_UI4;
  OID_SECURITY_RG_CERT_BAG        = $25 shl 16 or VT_VECTOR or VT_UI4;
  OID_SECURITY_HCRYPTPROV         = $26 shl 16 or VT_UI4;
  OID_SECURITY_SEARCHSTORES       = $27 shl 16 or VT_VECTOR or VT_UI4;
  OID_SECURITY_RG_IASN            = $28 shl 16 or VT_VECTOR or VT_UI4;
  OID_SECURITY_SYMCAPS            = $29 shl 16 or VT_BLOB;
  OID_SECURITY_AUTHATTR           = $2A shl 16 or VT_BLOB;
  OID_SECURITY_UNAUTHATTR         = $2B shl 16 or VT_BLOB;
  OID_SECURITY_SIGNTIME           = $2C shl 16 or VT_FILETIME;
  OID_SECURITY_USER_VALIDITY      = $2D shl 16 or VT_UI4;
  OID_SECURITY_RO_MSG_VALIDITY    = $2E shl 16 or VT_UI4;
  OID_SECURITY_CRL                = $2F shl 16 or VT_BLOB;
  OID_SECURITY_ENCODE_FLAGS       = $30 shl 16 or VT_UI4;
  OID_SECURITY_CERT_INCLUDED      = $31 shl 16 or VT_BOOL;
  OID_SECURITY_HWND_OWNER         = $32 shl 16 or VT_UI4;
  OID_SECURITY_REQUESTED_CTE      = $33 shl 16 or VT_UI4;
  OID_NO_DEFAULT_CNTTYPE          = $34 shl 16 or VT_BOOL;
  OID_XMIT_PLAIN_TEXT_ENCODING    = $35 shl 16 or VT_UI4;
  OID_XMIT_HTML_TEXT_ENCODING     = $36 shl 16 or VT_UI4;
  OID_HEADER_RELOAD_TYPE          = $37 shl 16 or VT_UI4;
  OID_CAN_INLINE_TEXT_BODIES      = $38 shl 16 or VT_BOOL;
  OID_SHOW_MACBINARY              = $39 shl 16 or VT_BOOL;
  OID_SAVEBODY_KEEPBOUNDARY       = $40 shl 16 or VT_BOOL;

  OID_SECURITY_ALG_HASH_RG        = $19 shl 16 or VT_VECTOR or VT_VARIANT;
  OID_SECURITY_CERT_SIGNING_RG    = $21 shl 16 or VT_VECTOR or VT_UI4;
  OID_SECURITY_SYMCAPS_RG         = $29 shl 16 or VT_VECTOR or VT_VARIANT;
  OID_SECURITY_AUTHATTR_RG        = $2A shl 16 or VT_VECTOR or VT_VARIANT;
  OID_SECURITY_UNAUTHATTR_RG      = $2B shl 16 or VT_VECTOR or VT_VARIANT;
  OID_SECURITY_SIGNTIME_RG        = $2C shl 16 or VT_VECTOR or VT_FILETIME;
  OID_SECURITY_USER_VALIDITY_RG   = $2D shl 16 or VT_VECTOR or VT_UI4;
  OID_SECURITY_RO_MSG_VALIDITY_RG = $2E shl 16 or VT_VECTOR or VT_UI4;

  OID_SUPPORT_EXTERNAL_BODY       = $41 shl 16 or VT_BOOL;
  OID_LOAD_USE_BIND_FILE          = $42 shl 16 or VT_BOOL;
  OID_SECURITY_SIGNATURE_COUNT    = $43 shl 16 or VT_UI4;
  OID_HANDSOFF_ONSAVE             = $44 shl 16 or VT_BOOL;
  OID_SECURITY_RECEIPT_RG         = $45 shl 16 or VT_VECTOR or VT_VARIANT;
  OID_NOSECURITY_ONSAVE           = $46 shl 16 or VT_BOOL;
  OID_DECODE_RFC1154              = $47 shl 16 or VT_BOOL;
  OID_SECURITY_MESSAGE_HASH_RG    = $4A shl 16 or VT_VECTOR or VT_VARIANT;
  OID_SECURITY_KEY_PROMPT         = $4B shl 16 or VT_LPWSTR;

  OID_SECURITY_ENCRYPT_CERT_BAG   = $4C shl 16 or VT_UI4;
  OID_SECURITY_2KEY_CERT_BAG      = $59 shl 16 or VT_VECTOR or VT_UI4;

type
  HBODY = THandle;
  PHBODY = ^HBODY;
  PPHBODY = ^PHBODY;
  HBODIES = array [0..65535] of HBODY;
  PHBODIES = ^HBODIES;

  HCHARSET = THandle;
  HADDRESS = THandle;
  HHEADERROW = THandle;
  HCERTSTORE = pointer;

  THUMBBLOB = BLOB;

  RELOADTYPE = DWORD;
  MIMESAVETYPE = DWORD;
  CSETAPPLYTYPE = DWORD;
  ENCODINGTYPE = DWORD;

  IMSGPRIORITY = DWORD;
  IMSGFLAGS = DWORD;
  BODYLOCATION = DWORD;
  IMSGBODYTYPE = DWORD;
  TYPEDID = DWORD;
  IADDRESSTYPE = DWORD;
  ADDRESSFORMAT = DWORD;
  CERTSTATE = DWORD;
  PCERTSTATE = ^CERTSTATE;

  CODEPAGEID = DWORD;
  CHARSETTYPE = DWORD;

  PROPINFOMASK = DWORD;

const
  CCHMAX_HEADER_LINE = 1000;

  IMSG_PRI_LOW       = 5;
  IMSG_PRI_NORMAL    = 3;
  IMSG_PRI_HIGH      = 1;

  IMF_ATTACHMENTS    = $00000001;   // The message has attachments
  IMF_MULTIPART      = $00000002;   // The message is a multipart message
  IMF_SUBMULTIPART   = $00000004;   // The message has a nested multipart section
  IMF_MIME           = $00000008;   // The message is in MIME format
  IMF_HTML           = $00000010;   // The message has a text/html body
  IMF_PLAIN          = $00000020;   // The message has a text/plain body
  IMF_PARTIAL        = $00000040;   // The message has un-matching boundaries; or is a message/partial
  IMF_SIGNED         = $00000080;   // The message is signed
  IMF_ENCRYPTED      = $00000100;   // The message is secured
  IMF_TNEF           = $00000200;   // The message has a Microsoft TNEF attachment
  IMF_MHTML          = $00000400;   // The message has a MIME-HTML multipart/related section
  IMF_SECURE         = $00000800;   // The message has a cryptographic enhancement
  IMF_TEXT           = $00001000;   // The message contains text/xxx part(s)
  IMF_CSETTAGGED     = $00002000;   // The message was tagged with a charset
  IMF_NEWS           = $00004000;   // The message has nntp (news) headers (Newsgroup; Path; etc)
  IMF_VOICEMAIL      = $00008000;   // The message has the X-Voicemail Header Set to something
  IMF_HASVCARD       = $00010000;   // The message has a text/v-card attachment.
  IMF_RFC1154        = $00020000;    // The message was decoded using RFC1154.

  WPF_HTML                         = $00000001;    // Full-fidelity HTML (if not set, mimeole will downgrade to plain-text)
  WPF_AUTOINLINE                   = $00000002;    // Inline images that are marked as attachment
  WPF_SLIDESHOW                    = $00000004;    // Show all inlined images in a slideshow
  WPF_ATTACHLINKS                  = $00000008;    // Put links to the attachments in the WebPage
  WPF_IMAGESONLY                   = $00000010;    // Only show inline images
  WPF_NOMETACHARSET                = $00000020;    // Only show inline images
  WPF_TEXTONLY                     = $00000040;    // No HTML tags whatsoever

  TXT_PLAIN                        = $00000001;
  TXT_HTML                         = $00000002;
  URL_ATTACH_INTO_MIXED            = $00000001;
  URL_ATTACH_GENERATE_CID          = $00000002;
  URL_ATTACH_SET_CNTTYPE           = $00000004;
  URL_RESOLVE_RENDERED             = $00000001;
  URL_RESULVE_NO_BASE              = $00000002;

  HBODY_ROOT : HBODY = HBODY(-1);

  IBL_ROOT = 0;                // Get the root body of the message
  IBL_PARENT = 1;              // Parent of pInRelation
  IBL_FIRST = 2;               // First Child
  IBL_LAST = 3;                // Last Child
  IBL_NEXT = 4;                 // Next Sibling
  IBL_PREVIOUS = 5;            // Previous Sibling

  COMMIT_ONLYIFDIRTY       = $00000001;
  COMMIT_REUSESTORAGE      = $00000002;
  COMMIT_SMIMETRANSFERENCODE = $00000004;

  DELETE_PROMOTE_CHILDREN = $00000001;
  DELETE_CHILDREN_ONLY    = $00000002;

  SAVEBODY_KEEPBOUNDARY   = $00000001;

  CSET_APPLY_UNTAGGED = 0;        // Apply the hCharset to all un-tagged properties or use as default on send
  CSET_APPLY_ALL      = 1;        // Apply the hCharset to all properties, including tagged properties
  CSET_APPLY_TAG_ALL  = 2;        // Apply the hCharset to all properties, including tagged properties, and mark things as tagged (IBT_CSETTAGGED)

  IBT_SECURE = 0;                         // Body has cryptographic enhancement(s)
  IBT_ATTACHMENT = 1;                     // Body is considered an attachment by mimeole
  IBT_EMPTY = 2;                          // Is the body empty
  IBT_CSETTAGGED = 3;                     // Is the body tagged with a character set?
  IBT_AUTOATTACH = 4;                     // If OID_CAN_INLINE_TEXT_BODIES is TRUE and the body was marked as an attachment by mimeole

  // -----------------------------------------------------------------------------------
  // ENCODINGTYPE     | Internet Charset  | Internet Encoding | Transmittable
  // -----------------------------------------------------------------------------------
  // IET_BINARY       | No                | No                | No
  // IET_BASE64       | Yes               | Yes               | Yes
  // IET_UUENCODE     | Yes               | Yes               | Yes
  // IET_QP           | Yes               | Yes               | Yes
  // IET_7BIT         | Yes               | No (Dot Stuffed)  | Yes
  // IET_8BIT         | Yes               | No (Dot Stuffed)  | Yes
  // -----------------------------------------------------------------------------------
  // -1 is reserved for an IMimeSecurity default
  IET_BINARY = 0;     // decoded (mime, uu, or stripped lead-dots)/windows charset
  IET_BASE64 = 1;     // Base64 encoded/internet charset
  IET_UUENCODE = 2;   // Uu encoded/internet charset
  IET_QP = 3;         // Quoted-Printable encoded/internet charset
  IET_7BIT = 4;       // non-encoded (lead-dots stuffed)/internet charset 7bit data
  IET_8BIT = 5;       // non-encoded (lead-dots stuffed)/internet charset 8bit data
  IET_INETCSET = 6;   // Decoded, but in an Internet Character Set
  IET_UNICODE = 7;    // Decoded in unicode
  IET_RFC1522 = 8;    // Header Encoding
  IET_ENCODED = 9;    // Used mostly for header properties (combines IET_INETCSET and IET_RFC1522)
  IET_CURRENT = 10;    // Use the current encoding of the body
  IET_UNKNOWN = 11;    // The encoding is unknown, can be treated as binary...
  IET_BINHEX40 = 12;   // Apple Macintosh Binhex
  IET_LAST = 13;       // Don't use

  IET_DECODED = IET_BINARY;


  IAT_UNKNOWN              = $00000000;
  IAT_FROM                 = $00000001;
  IAT_SENDER               = $00000002;
  IAT_TO                   = $00000004;
  IAT_CC                   = $00000008;
  IAT_BCC                  = $00000010;
  IAT_REPLYTO              = $00000020;
  IAT_RETURNPATH           = $00000040;
  IAT_RETRCPTTO            = $00000080;
  IAT_RR                   = $00000100;
  IAT_APPARTO              = $00000200;
  IAT_DISP_NOTIFICATION_TO = $00000400;
  IAT_ALL                  = $FFFFFFFF;
  IAT_KNOWN                = IAT_FROM or IAT_TO or IAT_CC or IAT_BCC or IAT_REPLYTO or IAT_SENDER;
  IAT_RECIPS               = IAT_TO or IAT_CC or IAT_BCC;

  AFT_DISPLAY_FRIENDLY = 0;                   // Display with friendly names only
  AFT_DISPLAY_EMAIL = 1;                      // Display with friendly email addresses only
  AFT_DISPLAY_BOTH = 2;                       // Display with friendly name and eamil addresses
  AFT_RFC822_DECODED = 3;                     // RFC822 Format (decoded)
  AFT_RFC822_ENCODED = 4;                     // RFC822 Format (encoded)
  AFT_RFC822_TRANSMIT = 5;                    // RFC822 Format (encoded) with CRLFs for folding

  IAP_CHARSET              = $00000001;
  IAP_HANDLE               = $00000002;
  IAP_ADRTYPE              = $00000004;
  IAP_FRIENDLY             = $00000008;
  IAP_EMAIL                = $00000020;
  IAP_CERTSTATE            = $00000100;
  IAP_SIGNING_PRINT        = $00000200;
  IAP_ENCRYPTION_PRINT     = $00000400;
  IAP_ENCODING             = $00000800;
  IAP_COOKIE               = $00001000;
  IAP_FRIENDLYW            = $00002000;
  IAP_ALL                  = $ffffffff;

  CERTIFICATE_OK = 0;                 // Only non-error state
  CERTIFICATE_NOT_PRESENT = 1;
  CERTIFICATE_EXPIRED = 2;            // Specific
  CERTIFICATE_CHAIN_TOO_LONG = 3;     //   |
  CERTIFICATE_MISSING_ISSUER = 4;     //   v
  CERTIFICATE_CRL_LISTED = 5;         // General
  CERTIFICATE_NOT_TRUSTED = 6;        // (Be as specific as possible)
  CERTIFICATE_INVALID = 7;
  CERTIFICATE_ERROR = 8;              // Last resort
  CERTIFICATE_NOPRINT = 9;            // no thumbprint provided
  CERTIFICATE_UNKNOWN = 10;           // Default

  SAVE_RFC822 = 0;        // Non-mime - UUENCODE
  SAVE_RFC1521 = 1;       // MIME

  RELOAD_HEADER_NONE = 0;
  RELOAD_HEADER_RESET = 1;
  RELOAD_HEADER_APPEND = 2;
  RELOAD_HEADER_REPLACE = 3;


  DEF_ALLOW_8BIT_HEADER           = FALSE;
  DEF_CBMAX_HEADER_LINE           = 1000;
  DEF_SAVE_FORMAT                 = SAVE_RFC1521;
  DEF_WRAP_BODY_TEXT              = TRUE;
  DEF_CBMAX_BODY_LINE             = 74;
  DEF_GENERATE_MESSAGE_ID         = FALSE;
  DEF_HASH_ALG_ID                 = $8004;  //SHA //N needed?")
  DEF_ENCRYPTION_ALG_ID           = $6602;  //RC2 //N needed?")
  DEF_INCLUDE_SENDER_CERT         = FALSE;
  DEF_HIDE_TNEF_ATTACHMENTS       = TRUE;
  DEF_CLEANUP_TREE_ON_SAVE        = TRUE;
  DEF_BODY_REMOVE_NBSP            = TRUE;
  DEF_SECURITY_IGNOREMASK         = 0;
  DEF_DBCS_ESCAPE_IS_8BIT         = FALSE;
  DEF_TRANSMIT_BODY_ENCODING      = IET_UNKNOWN;
  DEF_TRANSMIT_TEXT_ENCODING      = IET_UNKNOWN;
  DEF_XMIT_PLAIN_TEXT_ENCODING    = IET_UNKNOWN;
  DEF_XMIT_HTML_TEXT_ENCODING     = IET_UNKNOWN;
  DEF_NO_DEFAULT_CNTTYPE          = FALSE;
  DEF_HEADER_RELOAD_TYPE_TREE     = RELOAD_HEADER_RESET;
  DEF_HEADER_RELOAD_TYPE_PROPSET  = RELOAD_HEADER_NONE;
  DEF_CAN_INLINE_TEXT_BODIES      = FALSE;
  DEF_SHOW_MACBINARY              = FALSE;
  DEF_SAVEBODY_KEEPBOUNDARY       = FALSE;

  DEF_SUPPORT_EXTERNAL_BODY       = FALSE;
  DEF_LOAD_USE_BIND_FILE          = FALSE;
  DEF_HANDSOFF_ONSAVE             = FALSE;
  DEF_DECODE_RFC1154              = FALSE;

  MAX_CBMAX_HEADER_LINE           = $ffffffff;
  MIN_CBMAX_HEADER_LINE           = 76;
  MAX_CBMAX_BODY_LINE             = $ffffffff;
  MIN_CBMAX_BODY_LINE             = 30;

  CCHMAX_CSET_NAME = 128;
  CCHMAX_LANG_NAME = 128;
  CCHMAX_FACE_NAME = 128;

  CHARSET_BODY = 0;                                    // Corresponds to CODEPAGEINFO::szBodyCset
  CHARSET_HEADER = 1;                                  // Corresponds to CODEPAGEINFO::szHeaderCset
  CHARSET_WEB = 2;                                     // Corresponds to CODEPAGEINFO::szWebCset

  PDF_ENCODED             = $00000001;
  PDF_NAMEINDATA          = $00000002;
  PDF_HEADERFORMAT        = $00000004 or PDF_ENCODED;
  PDF_NOCOMMENTS          = $00000008;
  PDF_SAVENOENCODE        = $00000010;
  PDF_VECTOR              = $00000020;

  PIM_CHARSET         = $00000001;   // The MIMEPROPINFO::hCharset member is valid
  PIM_ENCODINGTYPE    = $00000002;   // The MIMEPROPINFO::ietEncoding member is valid
  PIM_ROWNUMBER       = $00000004;   // The MIMEPROPINFO::dwRowNumber member is valid
  PIM_FLAGS           = $00000008;   // The MIMEPROPINFO::dwFlags member is valid
  PIM_PROPID          = $00000010;   // The MIMEPROPINFO::dwPropId member is valid
  PIM_VALUES          = $00000020;   // The MIMEPROPINFO::cValues member is valid
  PIM_VTDEFAULT       = $00000040;   // The MIMEPROPINFO::vtDefault member is valid
  PIM_VTCURRENT       = $00000080;   // The MIMEPROPINFO::vtCurrent member is valid

  EPF_NONAME  = $00000001;

type
  INETCSETINFO = record
    szName : array [0..CCHMAX_CSET_NAME - 1] of CHAR;       // Character Set name
    Charset : HCHARSET;                       // Handle to this character set
    cpiWindows : CODEPAGEID;                     // Windows CodePage
    cpiInternet : CODEPAGEID;                    // Internet Code Page
    dwReserved1 : DWORD;                    // Reserved, don't use
  end;
  LPINETCSETINFO = ^INETCSETINFO;

  CODEPAGEINFO = record
    dwMask : DWORD;                          // Describes which fields are valid (INETLANGMASK)
    cpiCodePage : CODEPAGEID;                     // Handle to this charset (code page number / mlangid)
    fIsValidCodePage : BOOL;                // Value of IsValidCodePage(idCodePage)
    ulMaxCharSize : ULONG;                   // Maximum width of a character in this codepage
    fInternetCP : BOOL;                     // Is this an Internet Code Page
    cpiFamily : CODEPAGEID;                       // Windows Code page if fInternetCP == TRUE
    szName : array [0..CCHMAX_LANG_NAME - 1] of CHAR;        // Language Name
    szBodyCset : array [0..CCHMAX_CSET_NAME - 1] of CHAR;    // Charset to be used for the body
    szHeaderCset : array [0..CCHMAX_CSET_NAME - 1] of CHAR;  // Charset to be used for the Header
    szWebCset : array [0..CCHMAX_CSET_NAME - 1] of CHAR;     // Charset to be used for the body
    szFixedFont : array [0..CCHMAX_FACE_NAME - 1] of CHAR;   // Fixed Width Font Face Name
    szVariableFont : array [0..CCHMAX_FACE_NAME - 1] of CHAR;// Variable Width Font Face Name
    ietNewsDefault : ENCODINGTYPE;                  // Default news mime encoding (FMT_BASE64 or FMT_QP)
    ietMailDefault : ENCODINGTYPE;                  // Default mail mime encoding (FMT_BASE64 or FMT_QP)
    dwReserved1 : DWORD;                     // Reserved, don't use
  end;
  LPCODEPAGEINFO = ^CODEPAGEINFO;

  RFC1522INFO = record
    fRfc1522Allowed : BOOL;                 // Can rfc 1522 be used to encode/decode the header
    fRfc1522Used : BOOL;                    // Was rfc 1522 used to encode/decode the header
    fAllow8bit : BOOL;                      // Is 8bit allowed in the encoded header...
    hRfc1522Cset : HCHARSET;                    // The charset used in the rfc1522 encoded (DecodeHeader only)
  end;
  LPRFC1522INFO = ^RFC1522INFO;

  BODYOFFSETS = record
    cbBoundaryStart : DWORD;    // Offset of starting boundary for the body
    cbHeaderStart : DWORD;      // Header start offset
    cbBodyStart : DWORD;        // Body start offset (same as end of header)
    cbBodyEnd : DWORD;          // Body end offset
  end;
  LPBODYOFFSETS = ^BODYOFFSETS;

  FINDBODY = record
    pszPriType : LPSTR;
    pszSubType : LPSTR;
    dwReserved : DWORD;
  end;
  LPFINDBODY = ^FINDBODY;

  PCX509CERT = pointer;
  PPCX509CERT = ^PCX509CERT;

  X509CERTRESULT = record
    cEntries : DWORD;
    rgcs : PCERTSTATE;
    rgpCert : PPCX509CERT;
  end;

  PX509CERTRESULT = ^X509CERTRESULT;

  TRANSMITINFO = record
    ietCurrent : ENCODINGTYPE;         // Current encoding type of the data
    ietXmitMime : ENCODINGTYPE;        // Recommended Transmit Encoding
    ietXmit822 : ENCODINGTYPE;         // Recommended Transmit Encoding
    cbLongestLine : ULONG;      // Longest line seen, determines if wrapping is needed
    cExtended : ULONG;          // Count of Extended Characters
    ulPercentExt : ULONG;       // Percentage of extended characters in the body
    cbSize : ULONG;             // Number of bytes in the decoded data (exact)
    cLines : ULONG;             // Number of lines in the decoded data
  end;
  LPTRANSMITINFO = ^TRANSMITINFO;

  IMimeMessageTree = interface(IPersistStreamInit)
     [SID_IMimeMessageTree]
    function GetMessageSource(out ppStream : IStream; dwFlags : DWORD) : HResult; stdcall;
    function GetMessageSize(out pcbSize : ULONG; dwFlags : DWORD) : HResult; stdcall;
    function LoadOffsetTable(pStream : IStream) : HResult; stdcall;
    function SaveOffsetTable(pStream : IStream; dwFlags : DWORD) : HResult; stdcall;
    function GetFlags(out pdwFlags : DWORD) : HResult; stdcall;
    function Commit(dwFlags : DWORD) : HResult; stdcall;
    function HandsOffStorage : HResult; stdcall;
    function BindToObject(Body : HBODY; const riid : TIID; out ppvObject) : HResult; stdcall;
    function SaveBody(Body : HBODY; dwFlags : DWORD; pStream : IStream) : HResult; stdcall;
    function InsertBody(location : BODYLOCATION; hPivot : HBODY; out phBody : HBODY) : HResult; stdcall;
    function GetBody(location : BODYLOCATION; hPivot : HBODY; out phBody : HBODY) : HResult; stdcall;
    function DeleteBody(Body : HBODY; dwFlags : DWORD) : HResult; stdcall;
    function MoveBody(Body : HBODY; location : BODYLOCATION) : HResult; stdcall;
    function CountBodies(hParent : HBODY; fRecurse : boolean; out pcBodies : ULONG) : HResult; stdcall;
    function FindFirst(var pFindBody : FINDBODY; out phBody : HBODY) : HResult; stdcall;
    function FindNext(pFindBody : FINDBODY; out phBody : HBODY) : HResult; stdcall;
    function ResolveURL(hRelated : HBODY; pszBase : LPCSTR; pszURL : LPCSTR; dwFlags : DWORD; var phBody : HBODY) : HResult; stdcall;
    function ToMultipart(Body : HBODY; pszSubType : LPCSTR; var phMultipart : HBODY) : HResult; stdcall;
    function GetBodyOffsets(hBody : HBODY; var pOffsets : BODYOFFSETS) : HResult; stdcall;
    function GetCharset(out phCharset : HCHARSET) : HResult; stdcall;
    function SetCharset(hCharset : HCHARSET; applytype : CSETAPPLYTYPE) : HResult; stdcall;
    function IsBodyType(Body : HBODY; bodytype : IMSGBODYTYPE) : HResult; stdcall;
    function IsContentType(Body : HBODY; pszPriType : LPCSTR; pszSubType : LPCSTR) : HResult; stdcall;
    function QueryBodyProp(Body : HBODY; pszName : LPCSTR; pszCriteria : LPCSTR; fSubString : boolean; fCaseSensitive : boolean) : HResult; stdcall;
    function GetBodyProp(Body : HBODY; pszName : LPCSTR; dwFlags : DWORD; var pValue : PROPVARIANT) : HResult; stdcall;
    function SetBodyProp(Body : HBODY; pszName : LPCSTR; dwFlags : DWORD; const pValue : PROPVARIANT) : HResult; stdcall;
    function DeleteBodyProp(Body : HBODY; pszName : LPCSTR) : HResult; stdcall;
    function SetOption(const oid : TYPEDID; const pValue : PROPVARIANT) : HResult; stdcall;
    function GetOption(const oid : TYPEDID; var pValue : PROPVARIANT) : HResult; stdcall;
  end;


  TEXTTYPE = DWORD;

  WEBPAGEOPTIONS = record
    cbSize : DWORD;             // Size of this structure
    dwFlags : DWORD;            // WPF_xxx Flags
    dwDelay : DWORD;            // Delay time in milliseconds for auto-slide-show
    wchQuote : WCHAR;           // Quote char to use for reply ticking
    fQuoteSpaces : BOOL;       // Insert space between quote chars
  end;
  LPWEBPAGEOPTIONS = ^WEBPAGEOPTIONS;

  IMimeMessageCallback = interface(IUnknown)
    [SID_IMimeMessageCallback]
    // Returns S_OK if wrote something into pStream
    function OnWebPageSplitter(cInlined : DWORD; pStream : IStream) : HResult; stdcall;
  end;

  ADDRESSPROPS = record
    dwProps : DWORD;                // Mask of IAP_xxx flags for valid items in this structure
    Address : HADDRESS;               // IAP_HANDLE: Handle of this address
    ietFriendly : ENCODINGTYPE;            // IAP_ENCODING: Current encoding of pszFriendly
    Charset : HCHARSET;               // IAP_CHARSET: Charset used to encode pszFriendly
    dwAdrType : DWORD;              // IAP_ADRTYPE: Single IAT_xxx Flag, address type
    pszFriendly : LPSTR;            // IAP_FRIENDLYA: Friendly Name (ANSI)
    pszFriendlyW : LPWSTR;           // IAP_FRIENDLYW: Friendly Name (UNICODE)
    pszEmail : LPSTR;               // IAP_EMAIL: Email Address (ANSI)
    certstate : CERTSTATE;              // IAP_CERTSTATE: Certificate State
    tbSigning : THUMBBLOB;              // IAP_SIGNING_PRINT: Thumbprint to be used for signing
    tbEncryption : THUMBBLOB;           // IAP_ENCRYPTION_PRINT: Thumbprint to be used for signing
    dwCookie : DWORD;               // IAP_COOKIE: User-defined cookie
    dwReserved1 : DWORD;            // Reserved, dont use
    dwReserved2 : DWORD;            // Reserved, dont use
  end;
  LPADDRESSPROPS = ^ADDRESSPROPS;

  ADDRESSLIST = record
    cAdrs : ULONG;                  // Number of items in prgAddress
    prgAdr : LPADDRESSPROPS;                 // Pointer to an array of IMimeAddressInfo objects
  end;
  LPADDRESSLIST = ^ADDRESSLIST;

  ENUMPROPERTY = record
    pszName : LPSTR;
    hRow : HHEADERROW;
    dwPropId : DWORD;
  end;
  LPENUMPROPERTY = ^ENUMPROPERTY;

  IMimeEnumProperties = interface(IUnknown)
    [SID_IMimeEnumProperties]
    function Next(cFetch : ULONG; prgProp : LPENUMPROPERTY; pcFetched : PULONG) : HResult; stdcall;
    function Skip(cItems : ULONG) : HResult; stdcall;
    function Reset : HResult; stdcall;
    function Clone(out ppEnum : IMimeEnumProperties) : HResult; stdcall;
    function Count(out pcItems : ULONG) : HResult; stdcall;
  end;

  IMimeEnumAddressTypes = interface(IUnknown)
    [SID_IMimeEnumAddressTypes]
    function Next(cFetch : ULONG; prgAdr : LPADDRESSPROPS; pcFetched : PULONG) : HResult; stdcall;
    function Skip(cItems : ULONG) : HResult; stdcall;
    function Reset : HResult; stdcall;
    function Clone(out ppEnum : IMimeEnumAddressTypes) : HResult; stdcall;
    function Count(out pcItems : ULONG) : HResult; stdcall;
  end;

  IMimeMessage = interface;

  IMimeEnumMessageParts = interface(IUnknown)
    [SID_IMimeEnumMessageParts]
    function Next(cFetch : ULONG; prgpMessage : IMimeMessage; pcFetched : PULONG) : HResult; stdcall;
    function Skip(cItems : ULONG) : HResult; stdcall;
    function Reset : HResult; stdcall;
    function Clone(out ppEnum : IMimeEnumMessageParts) : HResult; stdcall;
    function Count(out pcItems : ULONG) : HResult; stdcall;
  end;

  MIMEPARAMINFO = record
    pszName : LPSTR;            // Parameter Name (i.e. charset)
    pszData : LPSTR;            // Paramater data
  end;
  LPMIMEPARAMINFO = ^MIMEPARAMINFO;

  MIMEPROPINFO = record
    dwMask : DWORD;             // What members in this structure are valid
    hCharset : HCHARSET;        // Property Charset
    ietEncoding : ENCODINGTYPE; // Encoded in an internet character set
    dwRowNumber : DWORD;        // Current header property row number
    dwFlags : DWORD;            // (GetPropInfo only) Property Flags (MIMEPROPFLAGS)
    dwPropId : DWORD;           // (GetPropInfo only) Property Id
    cValues : DWORD;            // (GetPropInfo only) Number of appended values (i.e. multi-line headers)
    vtDefault : TVARTYPE;        // The Default Data Type for this property
    vtCurrent : TVARTYPE;        // The Current Data Type for this property
  end;
  LPMIMEPROPINFO = ^MIMEPROPINFO;
  LPCMIMEPROPINFO = ^MIMEPROPINFO;

  IMimePropertySet = interface(IPersistStreamInit)
    [SID_IMimePropertySet]
    function GetPropInfo(pszName : LPCSTR; var pInfo : MIMEPROPINFO) : HResult; stdcall;
    function SetPropInfo(pszName : LPCSTR; const pInfo : MIMEPROPINFO) : HResult; stdcall;
    function GetProp(pszName : LPCSTR; dwFlags : DWORD; var pValue : PROPVARIANT) : HResult; stdcall;
    function SetProp(pszName : LPCSTR; dwFlags : DWORD; const pValue : PROPVARIANT) : HResult; stdcall;
    function AppendProp(pszName : LPCSTR; dwFlags : DWORD; const pValue : PROPVARIANT) : HResult; stdcall;
    function DeleteProp(pszName : LPCSTR) : HResult; stdcall;
    function CopyProps(cNames : ULONG; prgszName : PPAnsiChar; pPropertySet : IMimePropertySet) : HResult; stdcall;
    function MoveProps(cNames : ULONG; prgszName : PPAnsiChar; pPropertySet : IMimePropertySet) : HResult; stdcall;
    function DeleteExcept(cNames : ULONG; prgszName : PPAnsiChar) : HResult; stdcall;
    function QueryProp(pszName : LPCSTR; pszCriteria : LPCSTR; fSubString : boolean; fCaseSensitive : boolean) : HResult; stdcall;
    function GetCharset(out phCharset : HCHARSET) : HResult; stdcall;
    function SetCharset(Charset : HCHARSET; applytype : CSETAPPLYTYPE) : HResult; stdcall;
    function GetParameters(pszName : LPCSTR; out pcParams : ULONG; out pprgParam : MIMEPARAMINFO) : HResult; stdcall;
    function IsContentType(pszPriType : LPCSTR; pszSubType : LPCSTR) : HResult; stdcall;
    function BindToObject(const riid : TIID; out ppvObject) : HResult; stdcall;
    function Clone(out ppPropertySet : IMimePropertySet) : HResult; stdcall;
    function SetOption(const oid : TYPEDID; const pValue : PROPVARIANT) : HResult; stdcall;
    function GetOption(const oid : TYPEDID; var pValue : PROPVARIANT) : HResult; stdcall;
    function EnumProps(dwFlags : DWORD; out ppEnum : IMimeEnumProperties) : HResult; stdcall;
  end;

  IMimeBody = interface(IMimePropertySet)
    [SID_IMimeBody]
    function IsType(bodytype : IMSGBODYTYPE) : HResult; stdcall;
    function SetDisplayName(pszDisplay : LPCSTR) : HResult; stdcall;
    function GetDisplayName(out ppszDisplay : LPSTR) : HResult; stdcall;
    function GetOffsets(pOffsets : LPBODYOFFSETS) : HResult; stdcall;
    function GetCurrentEncoding(out pietEncoding : ENCODINGTYPE) : HResult; stdcall;
    function SetCurrentEncoding(ietEncoding : ENCODINGTYPE) : HResult; stdcall;
    function GetEstimatedSize(ietEncoding : ENCODINGTYPE; out pcbSize : ULONG) : HResult; stdcall;
    function GetDataHere(ietEncoding : ENCODINGTYPE; pStream : IStream) : HResult; stdcall;
    function GetData(ietEncoding : ENCODINGTYPE; out ppStream : IStream) : HResult; stdcall;
    function SetData(ietEncoding : ENCODINGTYPE; pszPriType : LPCSTR;
                     pszSubType : LPCSTR; const riid : TIID; out pvObject) : HResult; stdcall;
    function EmptyData : HResult; stdcall;
    function CopyTo(pBody : IMimeBody) : HResult; stdcall;
    function GetTransmitInfo(pTransmitInfo : LPTRANSMITINFO) : HResult; stdcall;
    function SaveToFile(ietEncoding : ENCODINGTYPE; pszFilePath : LPCSTR) : HResult; stdcall;
    function GetHandle(out phBody : HBODY) : HResult; stdcall;
  end;

  IMimeAddressTable = interface(IUnknown)
    [SID_IMimeAddressTable]
    function Append(dwAdrType : DWORD; ietFriendly : ENCODINGTYPE; pszFriendly : LPCSTR; pszEmail : LPCSTR; var phAddress : HADDRESS) : HResult; stdcall;
    function Insert(pAddress : LPADDRESSPROPS; phAddress : HADDRESS) : HResult; stdcall;
    function SetProps(hAddress : HADDRESS; pAddress : LPADDRESSPROPS) : HResult; stdcall;
    function GetProps(hAddress : HADDRESS; pAddress : LPADDRESSPROPS) : HResult; stdcall;
    function GetSender(var pAddress : ADDRESSPROPS) : HResult; stdcall;
    function CountTypes(dwAdrTypes : DWORD; out pcAdrs : ULONG) : HResult; stdcall;
    function GetTypes(dwAdrTypes : DWORD; dwProps : DWORD; var pList : ADDRESSLIST) : HResult; stdcall;
    function EnumTypes(dwAdrTypes : DWORD; dwProps : DWORD; out ppEnum : IMimeEnumAddressTypes) : HResult; stdcall;
    function Delete(hAddress : HADDRESS) : HResult; stdcall;
    function DeleteTypes(dwAdrTypes : DWORD) : HResult; stdcall;
    function GetFormat(dwAdrType : DWORD; format : ADDRESSFORMAT; out ppszFormat : LPSTR) : HResult; stdcall;
    function AppendRfc822(dwAdrType : DWORD; ietEncoding : ENCODINGTYPE; pszRfc822Adr : LPCSTR) : HResult; stdcall;
    function ParseRfc822(dwAdrType : DWORD; ietEncoding : ENCODINGTYPE; pszRfc822Adr : LPCSTR; var pList : ADDRESSLIST) : HResult; stdcall;
    function Clone(out ppTable : IMimeAddressTable) : HResult; stdcall;
    function BindToObject(const riid : TIID; out ppvObject) : HResult; stdcall;
  end;

  IMimeMessageParts = interface;

  IMimeMessage = interface(IMimeMessageTree)
    [SID_IMimeMessage]
    function CreateWebPage(pRootStm : IStream; pOptions : LPWEBPAGEOPTIONS; pCallback : IMimeMessageCallback; out ppMoniker : IMoniker) : HResult; stdcall;
    function GetProp(const pszName : LPCSTR; dwFlags : DWORD; var pValue : PROPVARIANT) : HResult; stdcall;
    function SetProp(const pszName : LPCSTR; dwFlags : DWORD; pValue : PPROPVARIANT) : HResult; stdcall;
    function DeleteProp(const pszName : LPCSTR) : HResult; stdcall;
    function QueryProp(const pszName : LPCSTR; const pszCriteria : LPCSTR; fSubString : boolean; fCaseSensitive : boolean) : HResult; stdcall;
    function GetTextBody(dwTxtType : DWORD; ietEncoding : ENCODINGTYPE; var ppStream : IStream; var phBody : HBODY) : HResult; stdcall;
    function SetTextBody(dwTxtType : DWORD; ietEncoding : ENCODINGTYPE; hAlternative : HBODY; pStream : IStream; var phBody : HBODY) : HResult; stdcall;
    function AttachObject(const riid : TIID; const pvObject; var phBody : HBODY) : HResult; stdcall;
    function AttachFile(const pszFilePath : LPCSTR; pstmFile : IStream; var phBody : HBODY) : HResult; stdcall;
    function AttachURL(const pszBase : LPCSTR; const pszURL : LPCSTR; dwFlags : DWORD;  pstmURL : IStream; var ppszCIDURL : LPSTR; out phBody : HBODY) : HResult; stdcall;
    function GetAttachments(out pcAttach : ULONG; out pprghAttach : PHBODY) : HResult; stdcall;
    function GetAddressTable(out ppTable : IMimeAddressTable) : HResult; stdcall;
    function GetSender(var pAddress : ADDRESSPROPS) : HResult; stdcall;
    function GetAddressTypes(dwAdrTypes : DWORD; dwProps : DWORD; var pList : ADDRESSLIST) : HResult; stdcall;
    function GetAddressFormat(dwAdrType : DWORD; format : ADDRESSFORMAT; out ppszFormat : LPSTR) : HResult; stdcall;
    function EnumAddressTypes(dwAdrTypes : DWORD; dwProps : DWORD; out ppEnum : IMimeEnumAddressTypes) : HResult; stdcall;
    function SplitMessage(cbMaxPart : ULONG; out ppParts : IMimeMessageParts) : HResult; stdcall;
    function GetRootMoniker(out ppMoniker : IMoniker) : HResult; stdcall;
  end;

  IMimeMessageParts = interface(IUnknown)
    [SID_IMimeMessageParts]
    function CombineParts(out ppMessage : IMimeMessage) : HResult; stdcall;
    function AddPart(pMessage : IMimeMessage) : HResult; stdcall;
    function SetMaxParts(cParts : ULONG) : HResult; stdcall;
    function CountParts(out pcParts : ULONG) : HResult; stdcall;
    function EnumParts(out ppEnum : IMimeEnumMessageParts) : HResult; stdcall;
  end;

const
  // --------------------------------------------------------------------------------")
  // CMDSETID_MimeEdit commands")
  // --------------------------------------------------------------------------------")
  MECMDID_DIRTY                =  1;
  MECMDID_EMPTY                =  2;
  MECMDID_STYLE                =  3;
  MECMDID_EDITHTML             =  4;
  MECMDID_DOWNGRADEPLAINTEXT   =  5;
  MECMDID_SETTEXT              =  6;
  MECMDID_ROT13                =  7;
  MECMDID_INSERTTEXTFILE       =  8;
  MECMDID_VIEWSOURCE           =  9;
  MECMDID_FORMATFONT           = 10;
  MECMDID_PREVIEWFORMAT        = 11;
  MECMDID_EDITMODE             = 12;
  MECMDID_CHARSET              = 13;
  MECMDID_SAVEASSTATIONERY     = 14;
  MECMDID_BACKGROUNDIMAGE      = 15;
  MECMDID_INSERTTEXT           = 16;
  MECMDID_INSERTHTML           = 17;
  MECMDID_BACKGROUNDCOLOR      = 18;
  MECMDID_APPLYDOCUMENT        = 19;
  MECMDID_SAVEATTACHMENTS      = 20;
  MECMDID_BACKGROUNDSOUND      = 21;
  MECMDID_INSERTBGSOUND        = 22;
  MECMDID_SHOWSOURCETABS       = 23;
  MECMDID_SETSOURCETAB	       = 24;
  MECMDID_TABLINKS             = 25;
  MECMDID_FORMATPARAGRAPH      = 26;
  MECMDID_CANENCODETEXT        = 27;
  MECMDID_RELOAD_EXTERNAL_CONTENT = 28;
  MECMDID_EXTERNAL_CONTENT_BLOCKED = 29;

// --------------------------------------------------------------------------------;
// MEO_FLAGS;  //used by MEHOSTCMDID_FLAGS
// --------------------------------------------------------------------------------;
  MEO_FLAGS_INCLUDEMSG             = $0001;    // include message when loading
  MEO_FLAGS_HTML                   = $0002;    // status of HTML mode
  MEO_FLAGS_AUTOINLINE             = $0004;    // want autoinlined attachments
  MEO_FLAGS_SLIDESHOW              = $0008;    // show autoinline images as slideshow
  MEO_FLAGS_AUTOTEXT               = $0010;    // autotext or not
  MEO_FLAGS_BLOCKQUOTE             = $0020;    // blockquote indentation on reply
  MEO_FLAGS_SENDIMAGES             = $0040;    // MHTML on or off
  MEO_FLAGS_DONTSPELLCHECKQUOTED   = $0080;    // don't spell check quoted text
  MEO_FLAGS_SENDEXTERNALIMGSRC     = $0100;    // send external image on reply/fwd
  MEO_FLAGS_REPLYATEND             = $0200;    // Insert replies at end of included messages

// --------------------------------------------------------------------------------;
// MECMDID_VIEWSOURCE options;
// --------------------------------------------------------------------------------;
  MECMD_VS_HTML                    = $0001;        // view HTML source
  MECMD_VS_MESSAGE                 = $0002;    // view message source

// --------------------------------------------------------------------------------;
// MEST_;  //used by MECMDID_SETSOURCETAB
// --------------------------------------------------------------------------------;
  MEST_EDIT					 =	0;    // goto the edit tab
  MEST_SOURCE	       =  1;    // goto the source tab
  MEST_PREVIEW       =  2;    // goto the preview tab
  MEST_NEXT	         =  3;    // goto the next tab
  MEST_PREVIOUS			 =	4;    // goto the previous tab

// --------------------------------------------------------------------------------;
// MECMDID_STYLE options;
// --------------------------------------------------------------------------------;
  MESTYLE_NOHEADER               = 0;     // no header at all
  MESTYLE_PREVIEW                = 1;     // preview header
  MESTYLE_FORMATBAR              = 2;     // formatting bar
  MESTYLE_MINIHEADER             = 3;     // mini header for focus changes

// --------------------------------------------------------------------------------;
// MECMDID_HEADER_TYLE options;
// --------------------------------------------------------------------------------;
  MEHEADER_NONE            = $00;
  MEHEADER_NEWS            = $01;
  MEHEADER_MAIL            = $02;
  MEHEADER_FORCE_ENGLISH   = $04;

// --------------------------------------------------------------------------------;
// MECMDID_SIGNATURE_ENABLED options;
// --------------------------------------------------------------------------------;
  MESIG_AUTO                = $0001;
  MESIG_MANUAL              = $0002;

// --------------------------------------------------------------------------------;
// MECMDID_SIGNATURE_OPTIONS options;
// --------------------------------------------------------------------------------;
  MESIGOPT_PLAIN            = $0001;
  MESIGOPT_TOP              = $0002;
  MESIGOPT_PREFIX           = $0004;
  MESIGOPT_BOTTOM           = $0008;
  MESIGOPT_HTML             = $0010;

// --------------------------------------------------------------------------------;
// MEHOSTCMDID_BORDERFLAGS options;
// --------------------------------------------------------------------------------;
  MEBF_OUTERCLIENTEDGE  = $0001;
  MEBF_INNERCLIENTEDGE  = $0002;
  MEBF_FORMATBARSEP     = $0004;
  MEBF_NOSCROLL         = $0008;

// --------------------------------------------------------------------------------;
// MEHOSTCMDID_SPELL_OPTIONS options;
// --------------------------------------------------------------------------------;
  MESPELLOPT_IGNORENUMBER      = $0001;
  MESPELLOPT_IGNOREUPPER       = $0002;
  MESPELLOPT_IGNOREDBCS        = $0004;
  MESPELLOPT_IGNOREPROTECT     = $0008;
  MESPELLOPT_IGNOREURL         = $0010;
  MESPELLOPT_ALWAYSSUGGEST     = $0020;
  MESPELLOPT_CHECKONSEND       = $0040;
  MESPELLOPT_CHECKONTYPE       = $0080;

// -------------------------------------------------------------------------------;
// MEHOSTCMDID_MESSAGE_TYPE options;
// -------------------------------------------------------------------------------;
  MEMESSAGETYPE_NEWS       = $0001;
  MEMESSAGETYPE_MAIL       = $0002;

// --------------------------------------------------------------------------------;
// MEHOSTCMDID_SOURCEEDIT_FLAGS options;
// --------------------------------------------------------------------------------;
  MESRCFLAGS_COLOR      = $0001;

// --------------------------------------------------------------------------------;
// CMDSETID_MimeEditHost commands;
// --------------------------------------------------------------------------------;
  MEHOSTCMDID_SIGNATURE_ENABLED   = 1;
  MEHOSTCMDID_SIGNATURE_OPTIONS   = 2;
  MEHOSTCMDID_SIGNATURE           = 3;
  MEHOSTCMDID_HEADER_TYPE         = 4;
  MEHOSTCMDID_ONPARSECOMPLETE     = 5;
  MEHOSTCMDID_FLAGS               = 6;
  MEHOSTCMDID_QUOTE_CHAR          = 7;
  MEHOSTCMDID_REPLY_TICK_COLOR    = 8;
  MEHOSTCMDID_COMPOSE_FONT        = 9;
  MEHOSTCMDID_ADD_TO_ADDRESSBOOK  = 10;
  MEHOSTCMDID_ADD_TO_FAVORITES    = 11;
  MEHOSTCMDID_SLIDESHOW_DELAY     = 12;
  MEHOSTCMDID_FONTCACHE           = 13;
  MEHOSTCMDID_BORDERFLAGS         = 14;
  MEHOSTCMDID_SECURITY_ZONE       = 15;
  MEHOSTCMDID_SPELL_OPTIONS       = 16;
  MEHOSTCMDID_SAVEATTACH_PATH     = 17;
  MEHOSTCMDID_SOURCEEDIT_FLAGS    = 18;
  MEHOSTCMDID_SPELL_LANGUAGE      = 19;
  MEHOSTCMDID_HTML_HELP           = 20;
  MEHOSTCMDID_UNSAFEATTACHMENTS   = 21;
  MEHOSTCMDID_IS_READ_IN_TEXT_ONLY = 22;
  MEHOSTCMDID_QUOTE_SPACES         = 23;
  MEHOSTCMDID_BLOCK_EXTERNAL_CONTENT = 24;
  MEHOSTCMDID_RELOAD_WITH_EXTERNAL_CONTENT = 25;
  MEHOSTCMDID_GETCOMPOSEFONT	    = 26;
  MEHOSTCMDID_RESETSETTINGS       = 27;
  MEHOSTCMDID_GETREADFONT         = 28;
  MEHOSTCMDID_MESSAGE_TYPE        = 29;
  MEHOSTCMDID_COMMUNITIES         = 30;
  MEHOSTCMDID_COMMUNITIES_SERVER  = 31;
  MEHOSTCMDID_PASSPORT_AUTHENTICATED = 32;
  MEHOSTCMDID_COMMUNITYSITE       = 33;
  MEHOSTCMDID_PASSPORT_MANAGER    = 34;
  MEHOSTCMDID_COMMUNITY_VOTE      = 35;
  MEHOSTCMDID_PHISHING_SITE       = 36;
  MEHOSTCMDID_CHARSET             = 37;

// --------------------------------------------------------------------------------;
// MimeOLE Exported C API Functions;
// --------------------------------------------------------------------------------;
  NOFLAGS                 = 0;
  CCHMAX_CID              = 255;
  CCHMAX_MID              = 255;
  CCHMAX_INTERNET_DATE    = 50;

  MECD_HTML                = $0001;
  MECD_PLAINTEXT           = $0002;
  MECD_ENCODEIMAGES        = $0004;
  MECD_ENCODEFILEURLSONLY  = $0008;
  MECD_ENCODESOUNDS        = $0010;
  MECD_ENCODEVIDEO         = $0020;
  MECD_ENCODEPLUGINS       = $0040;

// --------------------------------------------------------------------------------;
// MimeOLE API Prototypes;
// --------------------------------------------------------------------------------;
  MIMEOLE_COMPAT_OE5 = $00000001;
  MIMEOLE_COMPAT_MLANG2 = $00000002;

function MimeOleSetCompatMode(dwMode : DWORD) : HResult; stdcall;
function MimeOleContentTypeFromUrl(pszBase : LPCSTR; pszUrl : LPCSTR; out ppszCntType : LPSTR) : HResult; stdcall;
function MimeOleParseMhtmlUrl(pszUrl : LPSTR; out ppszRootUrl : LPSTR; out ppszBodyUrl : LPSTR) : HResult; stdcall;
function MimeOleObjectFromUrl(pszUrl : LPCSTR; fCreate : BOOL; const riid : TIID; out ppvObject; out ppUnkKeepAlive : IUnknown) : HResult; stdcall;
//function MimeOleObjectFromMoniker(abindf : BINDF; pmkOriginal : IMoniker; pBindCtx : IBindCtx; const riid : TIID; out ppvObject; out ppmkNew : IMoniker) : HResult; stdcall;
function MimeOleCombineURL(pszBase : LPCSTR; cchBase : ULONG; pszURL : LPCSTR; cchURL : ULONG; fUnEscape : BOOL; out ppszAbsolute : LPSTR) : HResult; stdcall;
//function MimeOleGetSubjectFileName(pPropertySet : IMimePropertySet; out pulPart : ULONG;
//                                   out pulTotal : ULONG; pszFileName : LPSTR; cchMax : ULONG) : HResult; stdcall;
//function MimeOleCreateWebDocument(pszBase : LPCSTR; pszURL : LPCSTR; out ppDocument : IMimeWebDocument) : HResult; stdcall;
function MimeOleGetRelatedSection(pTree : IMimeMessageTree; fCreate : boolean; out phRelated : HBODY; out pfMultiple : boolean) : HResult; stdcall;
function MimeOleGetMixedSection(pTree : IMimeMessageTree; fCreate : boolean; out phMixed : HBODY; out pfMultiple : boolean) : HResult; stdcall;
function MimeOleGetAlternativeSection(pTree : IMimeMessageTree; out phAlternative : HBODY; out pfMultiple : boolean) : HResult; stdcall;
function MimeOleGenerateCID(pszCID : LPSTR; cchMax : ULONG; fAbsolute : boolean) : HResult; stdcall;
function MimeOleGenerateMID(pszMID : LPSTR; cchMax : ULONG; fAbsolute : boolean) : HResult; stdcall;
function MimeOleCreateByteStream(out ppStream : IStream) : HResult; stdcall;
//function MimeOleGetPropertySchema(out ppSchema : IMimePropertySchema) : HResult; stdcall;
function MimeOleQueryString(pszSearchMe : LPCSTR; pszCriteria : LPCSTR; fSubString : boolean; fCaseSensitive : boolean) : HResult; stdcall;
//function MimeOleGetPropA(pPropertyset : IMimePropertySet; pszName : LPCSTR; dwFlags : DWORD; out ppszData : LPSTR) : HResult; stdcall;
//function MimeOleSetPropA(pPropertyset : IMimePropertySet; pszName : LPCSTR; dwFlags : DWORD; pszData : LPCSTR) : HResult; stdcall;
//function MimeOleGetPropW(pPropertyset : IMimePropertySet; pszName : LPCSTR; dwFlags : DWORD; out ppszData : LPWSTR) : HResult; stdcall;
//function MimeOleSetPropW(pPropertyset : IMimePropertySet; pszName : LPCSTR; dwFlags : DWORD; pszData : LPWSTR) : HResult; stdcall;
function MimeOleGetBodyPropA(pTree : IMimeMessageTree; Body : HBODY; pszName : LPCSTR; dwFlags : DWORD; out ppszData : LPSTR) : HResult; stdcall;
function MimeOleSetBodyPropA(pTree : IMimeMessageTree; Body : HBODY; pszName : LPCSTR;
                             dwFlags : DWORD; pszData : LPCSTR) : HResult; stdcall;
function MimeOleGetBodyPropW(pTree : IMimeMessageTree; Body : HBODY; pszName : LPCSTR;
                             dwFlags : DWORD; out ppszData : LPWSTR) : HResult; stdcall;
function MimeOleSetBodyPropW(pTree : IMimeMessageTree; Body : HBODY; pszName : LPCSTR;
                             dwFlags : DWORD; pszData : LPCWSTR) : HResult; stdcall;
//function MimeOleCreateHeaderTable(out ppTable : IMimeHeaderTable) : HResult; stdcall;
function MimeOleVariantFree(pProp : PPROPVARIANT) : HResult; stdcall;
function MimeOleVariantCopy(pDest : PPROPVARIANT; pSource : PPROPVARIANT) : HResult; stdcall;
function MimeOleGetExtClassId(pszExtension : LPCSTR; out pclsid : TCLSID) : HResult; stdcall;
function MimeOleEncodeHeader(Charset : HCHARSET; pData : PPROPVARIANT; out ppszEncoded : LPSTR; var pRfc1522Info : RFC1522INFO) : HResult; stdcall;
function MimeOleDecodeHeader(hCharset : HCHARSET; pszData : LPCSTR; out pDecoded : PROPVARIANT;
                             var pRfc1522Info : RFC1522INFO) : HResult; stdcall;
function MimeOleRfc1522Decode(pszValue : LPCSTR; pszCharset : LPSTR; cchmax : ULONG; out ppszDecoded : LPSTR) : HResult; stdcall;
function MimeOleRfc1522Encode(pszValue : LPCSTR; hCharset : HCHARSET; out ppszEncoded : LPSTR) : HResult; stdcall;
//function MimeOleGetInternat(out ppInternat : IMimeInternational) : HResult; stdcall;
function MimeOleFindCharset(pszCharset : LPCSTR; out phCharset : HCHARSET) : HResult; stdcall;
function MimeOleGetCharsetInfo(Charset : HCHARSET; out pCsetInfo : INETCSETINFO) : HResult; stdcall;
function MimeOleGetCodePageInfo(cpiCodePage : CODEPAGEID; out pCodePageInfo : CODEPAGEINFO) : HResult; stdcall;
function MimeOleGetDefaultCharset(out phCharset : HCHARSET) : HResult; stdcall;
function MimeOleSetDefaultCharset(Charset : HCHARSET) : HResult; stdcall;
function MimeOleGetCodePageCharset(cpiCodePage : CODEPAGEID; ctCsetType : CHARSETTYPE;
                                   out phCharset : HCHARSET) : HResult; stdcall;
function MimeOleCreateVirtualStream(out ppStream : IStream) : HResult; stdcall;
function MimeOleOpenFileStream(pszFilePath : LPCSTR; dwCreationDistribution : DWORD;
                               dwAccess : DWORD; out ppstmFile : IStream) : HResult; stdcall;
function MimeOleIsTnefStream(pStream : IStream) : HResult; stdcall;
function MimeOleGenerateFileName(pszContentType : LPCSTR; pszSuggest : LPCSTR;
                                 pszDefaultExt : LPCSTR; var ppszFileName : LPSTR) : HResult; stdcall;
function MimeOleGetFileExtension(pszFilePath : LPCSTR; pszExt : LPSTR; cchMax : ULONG) : HResult; stdcall;
//function MimeOleCreateSecurity(out ppSecurity : IMimeSecurity) : HResult; stdcall;
function MimeOleInetDateToFileTime(pszDate : LPCSTR; pft : PFILETIME) : HResult; stdcall;
function MimeOleFileTimeToInetDate(pft : PFILETIME; pszDate : LPSTR; cchMax : ULONG) : HResult; stdcall;
function MimeOleCreateMessageParts(out ppParts : IMimeMessageParts) : HResult; stdcall;
//function MimeOleGetAllocator(out ppAllocator : IMimeAllocator) : HResult; stdcall;
function MimeOleParseRfc822Address(dwAdrType : DWORD; ietEncoding : ENCODINGTYPE; pszRfc822Adr : LPCSTR; pList : LPADDRESSLIST) : HResult; stdcall;
function MimeOleCreateMessage(pUnkOuter : IUnknown; out ppMessage : IMimeMessage) : HResult; stdcall;
function MimeOleMergePartialHeaders(pstmIn : IStream; pstmOut : IStream) : HResult; stdcall;
function MimeOleEscapeString(cpiCodePage : CODEPAGEID; pszIn : LPCSTR; out ppszOut : LPSTR) : HResult; stdcall;
function MimeOleUnEscapeStringInPlace(pszin : LPSTR) : HResult; stdcall;
function MimeOleGetExtContentType(pszExtension : LPCSTR; out ppszContentType : LPSTR) : HResult; stdcall;
function MimeOleGetExtContentTypeW(pszExtension : LPCWSTR; out ppszContentType : LPWSTR) : HResult; stdcall;
function MimeOleGetContentTypeExt(pszContentType : LPCSTR; out ppszExtension : LPSTR) : HResult; stdcall;
function MimeOleGetFileInfo(pszFilePath : LPSTR; out ppszCntType : LPSTR;
                             out ppszSubType : LPSTR; out ppszCntDesc : LPSTR;
                             out ppszFileName : LPSTR; out ppszExtension : LPSTR) : HResult; stdcall;
function MimeOleGetFileInfoW(pszFilePath : LPWSTR; out ppszCntType : LPWSTR;
                             out ppszSubType : LPWSTR; out ppszCntDesc : LPWSTR;
                             out ppszFileName : LPWSTR; out ppszExtension : LPWSTR) : HResult; stdcall;
function MimeOleCreateBody(out ppBody : IMimeBody) : HResult; stdcall;
//function MimeOleCreatePropertySet(pUnkOuter : IUnknown; out ppPropertySet : IMimePropertySet) : HResult; stdcall;
function MimeOleCreateMessageTree(pUnkOuter : IUnknown; out ppMessageTree : IMimeMessageTree) : HResult; stdcall;
function MimeOleGetCertsFromThumbprints(const rgThumbprint : THUMBBLOB; pResults : PX509CERTRESULT;
                                        const rghCertStore : HCERTSTORE; const cCertStore : DWORD) : HResult; stdcall;
function MimeOleSplitMessage(pMessage : IMimeMessage; cbMaxPart : ULONG; out ppParts : IMimeMessageParts) : HResult; stdcall;
function MimeOleClearDirtyTree(pTree : IMimeMessageTree) : HResult; stdcall;
function MimeOleConvertEnrichedToHTML(codepage : CODEPAGEID; pIn : IStream; pOut : IStream) : HResult; stdcall;
function MimeOleIsEnrichedStream(pStream : IStream) : HResult; stdcall;
function MimeOleSMimeCapsToDlg(pbSMimeCaps : PBYTE; cbSMimeCaps : DWORD; cCerts : DWORD;
                               const rgCerts : PCX509CERT; hwndDlg : HWND; idEncAlgs : DWORD;
                               idSignAlgs : DWORD; idBlob : DWORD) : HResult; stdcall;
function MimeOleSMimeCapsFromDlg(wnd : HWND; idEncAlgs : DWORD; idSignAlgs : DWORD; idBlob : DWORD;
                                 pbSMimeCaps : PBYTE; var pcbSmimeCaps : DWORD) : HResult; stdcall;
function MimeOleSMimeCapInit(pbSMimeCap : PBYTE; cbSMimeCap : DWORD; out ppv : Pointer) : HResult; stdcall;
function MimeOleSMimeCapAddSMimeCap(pbSMimeCap : PBYTE; cbSMimeCap : DWORD; pv : Pointer) : HResult; stdcall;
function MimeOleSMimeCapAddCert(pbCert : PBYTE; cbCert : DWORD; fParanoid : BOOL; pv : Pointer) : HResult; stdcall;
function MimeOleSMimeCapGetEncAlg(pv : Pointer; pbEncode : PBYTE; var pcbEncode : DWORD; var pdwBits : DWORD) : HResult; stdcall;
function MimeOleSMimeCapGetHashAlg(pv : Pointer; pbEncode : PBYTE; var pcbEncode : DWORD; var pfBlobSign : DWORD) : HResult; stdcall;
function MimeOleSMimeCapRelease(pv : Pointer) : HResult; stdcall;
function MimeOleAlgNameFromSMimeCap(pb : PBYTE; cb : DWORD; out ppzProtocol : LPCSTR) : HResult; stdcall;
function MimeOleAlgStrengthFromSMimeCap(pb : PBYTE; cb : DWORD; fEncryption : BOOL; out pdwStrength : DWORD) : HResult; stdcall;
function MimeOleSMimeCapsFull(pv : pointer; fFullEncryption : BOOL; fFullSigning : BOOL;
                      		 		pbSymCaps : PBYTE; var pcbSymCaps : DWORD) : HResult; stdcall;
// function MimeOleCreateHashTable(dwSize : DWORD; fDupeKeys : BOOL; out ppHashTable : IHashTable) : HResult; stdcall;
function MimeOleStripHeaders(pMessage : IMimeMessage; Body : HBODY; pszNameDelete : LPCSTR;
                        pszHeaderAdd : LPCSTR; const ppStream : IStream) : HResult; stdcall;
function MimeOleParseRfc822AddressW(dwAdrType : DWORD; pwszRfc822Adr : LPCWSTR; out pList : ADDRESSLIST) : HResult; stdcall;

// --------------------------------------------------------------------------------;
// MimeEdit API Prototypes;
// --------------------------------------------------------------------------------;
function MimeEditViewSource(hwndParent : HWND; pMsg : IMimeMessage) : HResult; stdcall;
function MimeEditIsSafeToRun(hwndParent : HWND; lpszFileName : LPCSTR; fPrompt : BOOL) : HResult; stdcall;
function MimeEditVerifyTrust(hwndParent : HWND; lpszFileName : LPCSTR; lpszPathName : LPCSTR) : HResult; stdcall;
function MimeEditCreateMimeDocument(pDoc : IUnknown; pMsgSrc : IMimeMessage;
                                    dwFlags : DWORD; out ppMsg : IMimeMessage) : HResult; stdcall;
function MimeEditGetBackgroundImageUrl(pDoc : IUnknown; out pbstr : WideString) : HResult; stdcall;
function MimeEditDocumentFromStream(pstm : IStream; const riid : TIID; out ppDoc) : HResult; stdcall;

function MimeGetAddressFormatW(const riid : TIID; const pvObject; dwAdrType : DWORD;
                               format : ADDRESSFORMAT; out ppszFormat : LPWSTR) : HResult; stdcall;

//+-------------------------------------------------------------------------;
//  RecipientID;
//;
//  The value of dwRecepintType MUST be 0.;
//--------------------------------------------------------------------------;
const
  szOID_Microsoft_Encryption_Cert   = '1.3.6.1.4.1.311.16.4';

(* type
  CRYPT_RECIPIENT_ID = record
    dwRecipientType : DWORD;
    Issuer : CERT_NAME_BLOB;
    SerialNumber : CRYPT_INTEGER_BLOB;
  end;
  PCRYPT_RECIPIENT_ID = ^PCRYPT_RECIPIENT_ID;*)

implementation

const
  inetcom = 'inetcomm.dll';

function MimeOleSetCompatMode; external inetcom name 'MimeOleSetCompatMode';
function MimeOleContentTypeFromUrl; external inetcom name 'MimeOleContentTypeFromUrl';
function MimeOleParseMhtmlUrl; external inetcom name 'MimeOleParseMhtmlUrl';
function MimeOleObjectFromUrl; external inetcom name 'MimeOleObjectFromUrl';
//function MimeOleObjectFromMoniker; external inetcom name 'MimeOleObjectFromMoniker';
function MimeOleCombineURL; external inetcom name 'MimeOleCombineURL';
//function MimeOleGetSubjectFileName; external inetcom name 'MimeOleGetSubjectFileName';
//function MimeOleCreateWebDocument; external inetcom name 'MimeOleCreateWebDocument';
function MimeOleGetRelatedSection; external inetcom name 'MimeOleGetRelatedSection';
function MimeOleGetMixedSection; external inetcom name 'MimeOleGetMixedSection';
function MimeOleGetAlternativeSection; external inetcom name 'MimeOleGetAlternativeSection';
function MimeOleGenerateCID; external inetcom name 'MimeOleGenerateCID';
function MimeOleGenerateMID; external inetcom name 'MimeOleGenerateMID';
function MimeOleCreateByteStream; external inetcom name 'MimeOleCreateByteStream';
//function MimeOleGetPropertySchema; external inetcom name 'MimeOleGetPropertySchema';
function MimeOleQueryString; external inetcom name 'MimeOleQueryString';
//function MimeOleGetPropA; external inetcom name 'MimeOleGetPropA';
//function MimeOleSetPropA; external inetcom name 'MimeOleSetPropA';
//function MimeOleGetPropW; external inetcom name 'MimeOleGetPropW';
//function MimeOleSetPropW; external inetcom name 'MimeOleSetPropW';
function MimeOleGetBodyPropA; external inetcom name 'MimeOleGetBodyPropA';
function MimeOleSetBodyPropA; external inetcom name 'MimeOleSetBodyPropA';
function MimeOleGetBodyPropW; external inetcom name 'MimeOleGetBodyPropW';
function MimeOleSetBodyPropW; external inetcom name 'MimeOleSetBodyPropW';
//function MimeOleCreateHeaderTable; external inetcom name 'MimeOleCreateHeaderTable';
function MimeOleVariantFree; external inetcom name 'MimeOleVariantFree';
function MimeOleVariantCopy; external inetcom name 'MimeOleVariantCopy';
function MimeOleGetExtClassId; external inetcom name 'MimeOleGetExtClassId';
function MimeOleEncodeHeader; external inetcom name 'MimeOleEncodeHeader';
function MimeOleDecodeHeader; external inetcom name 'MimeOleDecodeHeader';
function MimeOleRfc1522Decode; external inetcom name 'MimeOleRfc1522Decode';
function MimeOleRfc1522Encode; external inetcom name 'MimeOleRfc1522Encode';
//function MimeOleGetInternat; external inetcom name 'MimeOleGetInternat';
function MimeOleFindCharset; external inetcom name 'MimeOleFindCharset';
function MimeOleGetCharsetInfo; external inetcom name 'MimeOleGetCharsetInfo';
function MimeOleGetCodePageInfo; external inetcom name 'MimeOleGetCodePageInfo';
function MimeOleGetDefaultCharset; external inetcom name 'MimeOleGetDefaultCharset';
function MimeOleSetDefaultCharset; external inetcom name 'MimeOleSetDefaultCharset';
function MimeOleGetCodePageCharset; external inetcom name 'MimeOleGetCodePageCharset';
function MimeOleCreateVirtualStream; external inetcom name 'MimeOleCreateVirtualStream';
function MimeOleOpenFileStream; external inetcom name 'MimeOleOpenFileStream';
function MimeOleIsTnefStream; external inetcom name 'MimeOleIsTnefStream';
function MimeOleGenerateFileName; external inetcom name 'MimeOleGenerateFileName';
function MimeOleGetFileExtension; external inetcom name 'MimeOleGetFileExtension';
//function MimeOleCreateSecurity; external inetcom name 'MimeOleCreateSecurity';
function MimeOleInetDateToFileTime; external inetcom name 'MimeOleInetDateToFileTime';
function MimeOleFileTimeToInetDate; external inetcom name 'MimeOleFileTimeToInetDate';
function MimeOleCreateMessageParts; external inetcom name 'MimeOleCreateMessageParts';
//function MimeOleGetAllocator; external inetcom name 'MimeOleGetAllocator';
function MimeOleParseRfc822Address; external inetcom name 'MimeOleParseRfc822Address';
function MimeOleCreateMessage; external inetcom name 'MimeOleCreateMessage';
function MimeOleMergePartialHeaders; external inetcom name 'MimeOleMergePartialHeaders';
function MimeOleEscapeString; external inetcom name 'MimeOleEscapeString';
function MimeOleUnEscapeStringInPlace; external inetcom name 'MimeOleUnEscapeStringInPlace';
function MimeOleGetExtContentType; external inetcom name 'MimeOleGetExtContentType';
function MimeOleGetExtContentTypeW; external inetcom name 'MimeOleGetExtContentTypeW';
function MimeOleGetContentTypeExt; external inetcom name 'MimeOleGetContentTypeExt';
function MimeOleGetFileInfo; external inetcom name 'MimeOleGetFileInfo';
function MimeOleGetFileInfoW; external inetcom name 'MimeOleGetFileInfoW';
function MimeOleCreateBody; external inetcom name 'MimeOleCreateBody';
//function MimeOleCreatePropertySet; external inetcom name 'MimeOleCreatePropertySet';
function MimeOleCreateMessageTree; external inetcom name 'MimeOleCreateMessageTree';
function MimeOleGetCertsFromThumbprints; external inetcom name 'MimeOleGetCertsFromThumbprints';
function MimeOleSplitMessage; external inetcom name 'MimeOleSplitMessage';
function MimeOleClearDirtyTree; external inetcom name 'MimeOleClearDirtyTree';
function MimeOleConvertEnrichedToHTML; external inetcom name 'MimeOleConvertEnrichedToHTML';
function MimeOleIsEnrichedStream; external inetcom name 'MimeOleIsEnrichedStream';
function MimeOleSMimeCapsToDlg; external inetcom name 'MimeOleSMimeCapsToDlg';
function MimeOleSMimeCapsFromDlg; external inetcom name 'MimeOleSMimeCapsFromDlg';
function MimeOleSMimeCapInit; external inetcom name 'MimeOleSMimeCapInit';
function MimeOleSMimeCapAddSMimeCap; external inetcom name 'MimeOleSMimeCapAddSMimeCap';
function MimeOleSMimeCapAddCert; external inetcom name 'MimeOleSMimeCapAddCert';
function MimeOleSMimeCapGetEncAlg; external inetcom name 'MimeOleSMimeCapGetEncAlg';
function MimeOleSMimeCapGetHashAlg; external inetcom name 'MimeOleSMimeCapGetHashAlg';
function MimeOleSMimeCapRelease; external inetcom name 'MimeOleSMimeCapRelease';
function MimeOleAlgNameFromSMimeCap; external inetcom name 'MimeOleAlgNameFromSMimeCap';
function MimeOleAlgStrengthFromSMimeCap; external inetcom name 'MimeOleAlgStrengthFromSMimeCap';
function MimeOleSMimeCapsFull; external inetcom name 'MimeOleSMimeCapsFull';
// function MimeOleCreateHashTable; external inetcom name 'MimeOleCreateHashTable';
function MimeOleStripHeaders; external inetcom name 'MimeOleStripHeaders';
function MimeOleParseRfc822AddressW; external inetcom name 'MimeOleParseRfc822AddressW';
function MimeEditViewSource; external inetcom name 'MimeEditViewSource';
function MimeEditIsSafeToRun; external inetcom name 'MimeEditIsSafeToRun';
function MimeEditVerifyTrust; external inetcom name 'MimeEditVerifyTrust';
function MimeEditCreateMimeDocument; external inetcom name 'MimeEditCreateMimeDocument';
function MimeEditGetBackgroundImageUrl; external inetcom name 'MimeEditGetBackgroundImageUrl';
function MimeEditDocumentFromStream; external inetcom name 'MimeEditDocumentFromStream';
function MimeGetAddressFormatW; external inetcom name 'MimeGetAddressFormatW';

end.
